%global momorel 3

%bcond_without unique_object
%bcond_with ada
#%%bcond_without do_test

%global DATE 20100630
%global SVNREV 161589
%global gcc_version 4.4.4
%global _unpackaged_files_terminate_build 0
%global multilib_64_archs sparc64 ppc64 s390x x86_64
%global include_gappletviewer 0
%ifarch %{ix86} x86_64 ia64 ppc ppc64 alpha
%if %{with ada}
%global build_ada 1
%else
%global build_ada 0
%endif
%else
%global build_ada 0
%endif
%global build_java 1
%ifarch %{sparc}
%global build_cloog 0
%else
%global build_cloog 1
%endif
%global build_libstdcxx_docs 1
# If you don't have already a usable gcc-java and libgcj for your arch,
# do on some arch which has it rpmbuild -bc --with java_tar gcc41.spec
# which creates libjava-classes-%{version}-%{release}.tar.bz2
# With this then on the new arch do rpmbuild -ba -v --with java_bootstrap gcc41.spec
%global bootstrap_java %{?_with_java_bootstrap:%{build_java}}%{!?_with_java_bootstrap:0}
%global build_java_tar %{?_with_java_tar:%{build_java}}%{!?_with_java_tar:0}
%ifarch s390x
%global multilib_32_arch s390
%endif
%ifarch sparc64
%global multilib_32_arch sparcv9
%endif
%ifarch ppc64
%global multilib_32_arch ppc
%endif
%ifarch x86_64
%global multilib_32_arch i686
%endif
Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc
%{?include_specopt}
%{?!do_test: %global do_test 0}

Version: %{gcc_version}
Release: %{momorel}m%{?dist}
# libgcc, libgfortran, libmudflap, libgomp, libstdc++ and crtstuff have
# GCC Runtime Exception.
License: GPLv3+ and "GPLv3+ with exceptions" and "GPLv2+ with exceptions"
Group: Development/Languages
# The source for this package was pulled from upstream's vcs.  Use the
# following commands to generate the tarball:
# svn export svn://gcc.gnu.org/svn/gcc/branches/redhat/gcc-4_4-branch@%{SVNREV} gcc-%{version}-%{DATE}
# tar cf - gcc-%{version}-%{DATE} | bzip2 -9 > gcc-%{version}-%{DATE}.tar.bz2
Source0: gcc-%{version}-%{DATE}.tar.bz2
Source1: libgcc_post_upgrade.c
Source2: README.libgcjwebplugin.so
Source3: protoize.1
URL: http://gcc.gnu.org
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# Need binutils with -pie support >= 2.14.90.0.4-4
# Need binutils which can omit dot symbols and overlap .opd on ppc64 >= 2.15.91.0.2-4
# Need binutils which handle -msecure-plt on ppc >= 2.16.91.0.2-2
# Need binutils which support .weakref >= 2.16.91.0.3-1
# Need binutils which support --hash-style=gnu >= 2.17.50.0.2-7
# Need binutils which support mffgpr and mftgpr >= 2.17.50.0.2-8
# Need binutils which support --build-id >= 2.17.50.0.17-3
# Need binutils which support %gnu_unique_object >= 2.19.51.0.14
# Need binutils which support .cfi_sections >= 2.19.51.0.14-3m
# Need binutils which support --no-add-needed >= 2.20.51.0.2-3m
BuildRequires: binutils >= 2.20.51.0.2-3m
# While gcc doesn't include statically linked binaries, during testing
# -static is used several times.
BuildRequires: glibc-static
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo, sharutils
# For VTA guality testing
BuildRequires: gdb
%if %{build_java}
BuildRequires: fastjar
BuildRequires: ecj, zip, unzip
%if %{bootstrap_java}
Source10: libjava-classes-%{version}-%{release}.tar.bz2
%else
BuildRequires: gcc-java, libgcj
%endif
%endif
# Make sure pthread.h doesn't contain __thread tokens
# Make sure glibc supports stack protector
# Make sure glibc supports DT_GNU_HASH
BuildRequires: glibc-devel >= 2.4.90-13
BuildRequires: elfutils-devel >= 0.72
%ifarch ppc ppc64 s390 s390x sparc sparcv9 alpha
# Make sure glibc supports TFmode long double
BuildRequires: glibc >= 2.3.90-35
%endif
%ifarch %{multilib_64_archs} sparcv9 ppc
# Ensure glibc{,-devel} is installed for both multilib arches
BuildRequires: /lib/libc.so.6 /usr/lib/libc.so /lib64/libc.so.6 /usr/lib64/libc.so
%endif
%if %{build_ada}
# Ada requires Ada to build
BuildRequires: gcc-gnat >= 3.1, libgnat >= 3.1
%endif
%ifarch ia64
BuildRequires: libunwind >= 0.98
%endif
%if %{build_cloog}
BuildRequires: ppl >= 0.10, ppl-devel >= 0.10, cloog-ppl >= 0.15, cloog-ppl-devel >= 0.15
%endif
%if %{build_libstdcxx_docs}
BuildRequires: doxygen
BuildRequires: graphviz
%endif
#%%if #%%{with do_test}
%if %{do_test}
BuildRequires: autogen
%endif
Requires: cpp = %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
# Need --as-needed/--no-as-needed support
# On ppc64, need omit dot symbols support and --non-overlapping-opd
# Need binutils that owns /usr/bin/c++filt
# Need binutils that support .weakref
# Need binutils that supports --hash-style=gnu
# Need binutils that support mffgpr/mftgpr
# Need binutils that support --build-id
# Need binutils that support %gnu_unique_object
# Need binutils that support .cfi_sections
# Need binutils that support --no-add-needed
Requires: binutils >= 2.20.51.0.2-3m
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
%ifarch ppc ppc64 s390 s390x sparc sparcv9 alpha
# Make sure glibc supports TFmode long double
Requires: glibc >= 2.3.90-35
%endif
Requires: libgcc >= %{version}-%{release}
Requires: libgomp = %{version}-%{release}
%if !%{build_ada}
Obsoletes: gcc-gnat < %{version}-%{release}
Obsoletes: libgnat < %{version}-%{release}
%endif
%if %{build_cloog}
Requires: cloog-ppl >= 0.15
%endif
Requires(post): info
Requires(preun): info
AutoReq: true

Patch0: gcc44-hack.patch
Patch1: gcc44-build-id.patch
Patch2: gcc44-c++-builtin-redecl.patch
Patch3: gcc44-ia64-libunwind.patch
Patch4: gcc44-java-nomulti.patch
Patch5: gcc44-ppc32-retaddr.patch
Patch6: gcc44-pr33763.patch
Patch7: gcc44-rh330771.patch
Patch8: gcc44-i386-libgomp.patch
Patch9: gcc44-sparc-config-detection.patch
Patch10: gcc44-libgomp-omp_h-multilib.patch
Patch11: gcc44-libtool-no-rpath.patch
Patch12: gcc44-cloog-dl.patch
Patch13: gcc44-unwind-debug-hook.patch
Patch14: gcc44-pr38757.patch
Patch15: gcc44-libstdc++-docs.patch
Patch16: gcc44-ppc64-aixdesc.patch
Patch17: gcc44-no-add-needed.patch
Patch18: gcc44-pr44542.patch

# On ARM EABI systems, we do want -gnueabi to be part of the
# target triple.
%ifnarch %{arm}
%global _gnu %{nil}
%endif
%ifarch sparcv9
%global gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%global gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparcv9 ppc
%global gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection version 4.4.
You'll need this package in order to compile C code.

%package -n libgcc
Summary: GCC version 4.4 shared support library
Group: System Environment/Libraries
Provides: /usr/sbin/libgcc_post_upgrade
Autoreq: false

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libstdc++ = %{version}-%{release}
Requires: libstdc++-devel = %{version}-%{release}
Autoreq: true

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Autoreq: true
%if %{with unique_object}
Requires: glibc >= 2.10.90-1m
%endif

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++ = %{version}-%{release}
Autoreq: true

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package -n libstdc++-docs
Summary: Documentation for the GNU standard C++ library
Group: Development/Libraries
Autoreq: true

%description -n libstdc++-docs
Manual, doxygen generated API information and Frequently Asked Questions
for the GNU standard C++ library.

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
Autoreq: true

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package objc++
Summary: Objective-C++ support for GCC
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-objc = %{version}-%{release}
Autoreq: true

%description objc++
gcc-objc++ package provides Objective-C++ support for the GCC.

%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%package gfortran
Summary: Fortran support
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgfortran = %{version}-%{release}
BuildRequires: gmp-devel >= 4.1.2-8, mpfr-devel >= 2.2.1
Requires(post): info
Requires(preun): info
Autoreq: true

%description gfortran
The gcc-gfortran package provides support for compiling Fortran
programs with the GNU Compiler Collection.

%package -n libgfortran
Summary: Fortran runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libgfortran
This package contains Fortran shared library which is needed to run
Fortran dynamically linked programs.

%package -n libgomp
Summary: GCC OpenMP v3.0 shared support library
Group: System Environment/Libraries
Requires(post): info
Requires(preun): info

%description -n libgomp
This package contains GCC shared support library which is needed
for OpenMP v3.0 support.

%package -n libmudflap
Summary: GCC mudflap shared support library
Group: System Environment/Libraries

%description -n libmudflap
This package contains GCC shared support library which is needed
for mudflap support.

%package -n libmudflap-devel
Summary: GCC mudflap support
Group: Development/Libraries
Requires: libmudflap = %{version}-%{release}
Requires: gcc = %{version}-%{release}

%description -n libmudflap-devel
This package contains headers and static libraries for building
mudflap-instrumented programs.

To instrument a non-threaded program, add -fmudflap
option to GCC and when linking add -lmudflap, for threaded programs
also add -fmudflapth and -lmudflapth.

%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgcj = %{version}-%{release}
Requires: libgcj-devel = %{version}-%{release}
Requires: ecj
Requires(post): info
Requires(preun): info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Requires(post): info
Requires(preun): info
Requires: zip >= 2.1
Requires: gtk2 >= 2.4.0
Requires: glib2 >= 2.4.0
Requires: libart_lgpl >= 2.1.0
Requires: fastjar
%if %{build_java}
BuildRequires: gtk2-devel >= 2.4.0
BuildRequires: glib2-devel >= 2.4.0
%if %{include_gappletviewer}
BuildRequires: xulrunner-devel
%endif
BuildRequires: libart_lgpl-devel >= 2.1.0
BuildRequires: alsa-lib-devel
BuildRequires: libXtst-devel
BuildRequires: libXt-devel
%endif
Autoreq: true

%description -n libgcj
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: libgcj = %{version}-%{release}
Requires: zlib-devel
Requires: /bin/awk
Autoreq: false
Autoprov: false

%description -n libgcj-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).

%package -n libgcj-src
Summary: Java library sources from GCC4 preview
Group: System Environment/Libraries
Requires: libgcj = %{version}-%{release}
Autoreq: true

%description -n libgcj-src
The Java(tm) runtime library sources for use in Eclipse.

%package -n cpp
Summary: The C Preprocessor
Group: Development/Languages
Requires(post): info
Requires(preun): info
Autoreq: true

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%package gnat
Summary: Ada 95 support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgnat = %{version}-%{release}, libgnat-devel = %{version}-%{release}
Requires(post): info
Requires(preun): info
Autoreq: true

%description gnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes development tools,
the documents and Ada 95 compiler.

%package -n libgnat
Summary: GNU Ada 95 runtime shared libraries
Group: System Environment/Libraries
Autoreq: true

%description -n libgnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes shared libraries,
which are required to run programs compiled with the GNAT.

%package -n libgnat-devel
Summary: GNU Ada 95 libraries
Group: System Environment/Libraries
Autoreq: true

%description -n libgnat-devel
GNAT is a GNU Ada 95 front-end to GCC. This package includes libraries,
which are required to compile with the GNAT.

%prep
%setup -q -n gcc-%{version}-%{DATE}
%patch0 -p0 -b .hack~
%patch1 -p0 -b .build-id~
%patch2 -p0 -b .c++-builtin-redecl~
%patch3 -p0 -b .ia64-libunwind~
%patch4 -p0 -b .java-nomulti~
%patch5 -p0 -b .ppc32-retaddr~
%patch6 -p0 -b .pr33763~
%patch7 -p0 -b .rh330771~
%patch8 -p0 -b .i386-libgomp~
%patch9 -p0 -b .sparc-config-detection~
%patch10 -p0 -b .libgomp-omp_h-multilib~
%patch11 -p0 -b .libtool-no-rpath~
%if %{build_cloog}
%patch12 -p0 -b .cloog-dl~
%endif
%patch13 -p0 -b .unwind-debug-hook~
%patch14 -p0 -b .pr38757~
%if %{build_libstdcxx_docs}
%patch15 -p0 -b .libstdc++-docs~
%endif
%patch16 -p0 -b .ppc64-aixdesc~
%patch17 -p0 -b .no-add-needed~
%patch18 -p0 -b .pr44542~

# This testcase doesn't compile.
rm libjava/testsuite/libjava.lang/PR35020*

%if %{bootstrap_java}
tar xjf %{SOURCE10}
%endif

sed -i -e 's/4\.4\.5/4.4.4/' gcc/BASE-VER
echo 'Momonga Linux %{momonga} %{version}-%{release}' > gcc/DEV-PHASE

# Default to -gdwarf-3 rather than -gdwarf-2
sed -i '/UInteger Var(dwarf_version)/s/Init(2)/Init(3)/' gcc/common.opt
sed -i 's/\(may be either 2 or 3; the default version is \)2\./\13./' gcc/doc/invoke.texi

cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

# Hack to avoid building multilib libjava
perl -pi -e 's/^all: all-redirect/ifeq (\$(MULTISUBDIR),)\nall: all-redirect\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-redirect/ifeq (\$(MULTISUBDIR),)\ninstall: install-redirect\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-redirect/ifeq (\$(MULTISUBDIR),)\ncheck: check-redirect\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^all: all-recursive/ifeq (\$(MULTISUBDIR),)\nall: all-recursive\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-recursive/ifeq (\$(MULTISUBDIR),)\ninstall: install-recursive\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-recursive/ifeq (\$(MULTISUBDIR),)\ncheck: check-recursive\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in

./contrib/gcc_update --touch

LC_ALL=C sed -i -e 's/\xa0/ /' gcc/doc/options.texi

%ifarch ppc
if [ -d libstdc++-v3/config/abi/post/powerpc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/post/powerpc64-linux-gnu/64
  mv libstdc++-v3/config/abi/post/powerpc64-linux-gnu/{,64/}baseline_symbols.txt
  mv libstdc++-v3/config/abi/post/powerpc64-linux-gnu/{32/,}baseline_symbols.txt
  rm -rf libstdc++-v3/config/abi/post/powerpc64-linux-gnu/32
fi
%endif
%ifarch sparc
if [ -d libstdc++-v3/config/abi/post/sparc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/post/sparc64-linux-gnu/64
  mv libstdc++-v3/config/abi/post/sparc64-linux-gnu/{,64/}baseline_symbols.txt
  mv libstdc++-v3/config/abi/post/sparc64-linux-gnu/{32/,}baseline_symbols.txt
  rm -rf libstdc++-v3/config/abi/post/sparc64-linux-gnu/32
fi
%endif

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

%if %{build_java}
%if !%{bootstrap_java}
# If we don't have gjavah in $PATH, try to build it with the old gij
mkdir java_hacks
cd java_hacks
cp -a ../../libjava/classpath/tools/external external
mkdir -p gnu/classpath/tools
cp -a ../../libjava/classpath/tools/gnu/classpath/tools/{common,javah,getopt} gnu/classpath/tools/
cp -a ../../libjava/classpath/tools/resource/gnu/classpath/tools/common/Messages.properties gnu/classpath/tools/common
cp -a ../../libjava/classpath/tools/resource/gnu/classpath/tools/getopt/Messages.properties gnu/classpath/tools/getopt
cd external/asm; for i in `find . -name \*.java`; do gcj --encoding ISO-8859-1 -C $i -I.; done; cd ../..
for i in `find gnu -name \*.java`; do gcj -C $i -I. -Iexternal/asm/; done
gcj -findirect-dispatch -O2 -fmain=gnu.classpath.tools.javah.Main -I. -Iexternal/asm/ `find . -name \*.class` -o gjavah.real
cat > gjavah <<EOF
#!/bin/sh
export CLASSPATH=`pwd`${CLASSPATH:+:$CLASSPATH}
exec `pwd`/gjavah.real "\$@"
EOF
chmod +x `pwd`/gjavah
cat > ecj1 <<EOF
#!/bin/sh
exec gij -cp /usr/share/java/eclipse-ecj.jar org.eclipse.jdt.internal.compiler.batch.GCCMain "\$@"
EOF
chmod +x `pwd`/ecj1
export PATH=`pwd`${PATH:+:$PATH}
cd ..
%endif
%endif

CC=gcc
OPT_FLAGS=`echo %{optflags}|sed -e 's/\(-Wp,\)\?-D_FORTIFY_SOURCE=[12]//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g;s/-m32//g;s/-m31//g'`
%ifarch sparc
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g;s/-mcpu=v[78]//g'`
%endif
%ifarch %{ix86}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-march=i.86//g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
OPT_FLAGS=`echo "$OPT_FLAGS" | sed -e 's/[[:blank:]]\+/ /g'`
case "$OPT_FLAGS" in
  *-fasynchronous-unwind-tables*)
    sed -i -e 's/-fno-exceptions /-fno-exceptions -fno-asynchronous-unwind-tables/' \
      ../gcc/Makefile.in
    ;;
esac
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="`echo $OPT_FLAGS | sed 's/ -Wall / /g'`" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	GCJFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--with-bugurl=http://developer.momonga-linux.org/kagemai/ --enable-bootstrap \
	--enable-shared --enable-threads=posix --enable-checking=release \
	--with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions \
%if %{with unique_object}
	--enable-gnu-unique-object \
%endif
%if !%{build_ada}
	--enable-languages=c,c++,objc,obj-c++,java,fortran \
%else
	--enable-languages=c,c++,objc,obj-c++,java,fortran,ada \
%endif
%if !%{build_java}
	--disable-libgcj \
%else
	--enable-java-awt=gtk --disable-dssi \
%if %{include_gappletviewer}
	--enable-plugin \
%endif
	--with-java-home=%{_prefix}/lib/jvm/java-1.5.0-gcj-1.5.0.0/jre \
	--enable-libgcj-multifile \
%if !%{bootstrap_java}
	--enable-java-maintainer-mode \
%endif
	--with-ecj-jar=/usr/share/java/eclipse-ecj.jar \
	--disable-libjava-multilib \
%endif
%if %{build_cloog}
	--with-ppl --with-cloog \
%endif
%ifarch %{arm}
	--disable-sjlj-exceptions \
%endif
%ifarch ppc ppc64
	--enable-secureplt \
%endif
%ifarch sparc sparcv9 sparc64 ppc ppc64 s390 s390x alpha
	--with-long-double-128 \
%endif
%ifarch sparc
	--disable-linux-futex \
%endif
%ifarch sparc64
	--with-cpu=ultrasparc \
%endif
%ifarch sparc sparcv9
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc ppc64
	--with-cpu-32=power4 --with-tune-32=power6 --with-cpu-64=power4 --with-tune-64=power6 \
%endif
%ifarch ppc
	--build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifarch %{ix86} x86_64
	--with-tune=generic \
%endif
%ifarch %{ix86}
	--with-arch=i686 \
%endif
%ifarch x86_64
	--with-arch_32=i686 \
%endif
%ifarch s390 s390x
	--with-arch=z9-109 --with-tune=z10 --enable-decimal-float \
%endif
%ifnarch sparc sparcv9 ppc
	--build=%{gcc_target_platform}
%endif

#GCJFLAGS="$OPT_FLAGS" make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap
GCJFLAGS="$OPT_FLAGS" make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" profiledbootstrap

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Make generated doxygen pages.
%if %{build_libstdcxx_docs}
cd %{gcc_target_platform}/libstdc++-v3
make doc-html-doxygen
make doc-man-doxygen
cd ../..
%endif

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/gfortran rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/libffi rpm.doc/libjava
mkdir -p rpm.doc/changelogs/{gcc/cp,gcc/java,gcc/ada,libstdc++-v3,libobjc,libmudflap,libgomp}
sed -e 's,@VERSION@,%{gcc_version},' %{SOURCE2} > rpm.doc/README.libgcjwebplugin.so

for i in {gcc,gcc/cp,gcc/java,gcc/ada,libstdc++-v3,libobjc,libmudflap,libgomp}/ChangeLog*; do
	cp -p $i rpm.doc/changelogs/$i
done

(cd gcc/fortran; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/gfortran/$i
done)
(cd libgfortran; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/gfortran/$i.libgfortran
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)
cp -p libjava/LIBGCJ_LICENSE rpm.doc/libjava/

rm -f rpm.doc/changelogs/gcc/ChangeLog.[1-9]
find rpm.doc -name \*ChangeLog\* | xargs bzip2 -9

%if %{build_java_tar}
find libjava -name \*.h -type f | xargs grep -l '// DO NOT EDIT THIS FILE - it is machine generated' > libjava-classes.list
find libjava -name \*.class -type f >> libjava-classes.list
find libjava/testsuite -name \*.jar -type f >> libjava-classes.list
tar cf - -T libjava-classes.list | bzip2 -9 > $RPM_SOURCE_DIR/libjava-classes-%{version}-%{release}.tar.bz2
%endif

%install
rm -fr %{buildroot}

cd obj-%{gcc_target_platform}

%if %{build_java}
%if !%{bootstrap_java}
export PATH=`pwd`/java_hacks${PATH:+:$PATH}
%endif
%endif

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ Makefiles
make -C %{gcc_target_platform}/libstdc++-v3

make prefix=%{buildroot}%{_prefix} mandir=%{buildroot}%{_mandir} \
  infodir=%{buildroot}%{_infodir} install
%if %{build_java}
make DESTDIR=%{buildroot} -C %{gcc_target_platform}/libjava install-src.zip
%endif
%if %{build_ada}
chmod 644 %{buildroot}%{_infodir}/gnat*
%endif

FULLPATH=%{buildroot}%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
FULLEPATH=%{buildroot}%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}

# fix some things
ln -sf gcc %{buildroot}%{_prefix}/bin/cc
mkdir -p %{buildroot}/lib
ln -sf ..%{_prefix}/bin/cpp %{buildroot}/lib/cpp
ln -sf gfortran %{buildroot}%{_prefix}/bin/f95
rm -f %{buildroot}%{_infodir}/dir
ln -sf gcc %{buildroot}%{_prefix}/bin/gnatgcc

cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"
for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    cat > %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/32/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%endif
#else
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/64/libstdc++-v3/include -name c++config.h)`
%endif
#endif
#endif
EOF
    break
  fi
done

for f in `find %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/ -name c++config.h`; do
  for i in 1 2 4 8; do
    sed -i -e 's/#define _GLIBCXX_ATOMIC_BUILTINS_'$i' 1/#ifdef __GCC_HAVE_SYNC_COMPARE_AND_SWAP_'$i'\
&\
#endif/' $f
  done
done

# Nuke bits/stdc++.h.gch dirs
# 1) there is no bits/stdc++.h header installed, so when gch file can't be
#    used, compilation fails
# 2) sometimes it is hard to match the exact options used for building
#    libstdc++-v3 or they aren't desirable
# 3) there are multilib issues, conflicts etc. with this
# 4) it is huge
# People can always precompile on their own whatever they want, but
# shipping this for everybody is unnecessary.
rm -rf %{buildroot}%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/bits/stdc++.h.gch

%if %{build_libstdcxx_docs}
libstdcxx_doc_builddir=%{gcc_target_platform}/libstdc++-v3/doc/doxygen
mkdir -p ../rpm.doc/libstdc++-v3
cp -r -p ../libstdc++-v3/doc/html ../rpm.doc/libstdc++-v3/html
mv $libstdcxx_doc_builddir/html ../rpm.doc/libstdc++-v3/html/api
mkdir -p %{buildroot}%{_mandir}
mv $libstdcxx_doc_builddir/man/man3 %{buildroot}%{_mandir}/man3/
find ../rpm.doc/libstdc++-v3 -name \*~ | xargs rm
%endif

%ifarch sparcv9 sparc64
ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
  %{buildroot}%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc ppc64
ln -f %{buildroot}%{_prefix}/bin/%{gcc_target_platform}-gcc \
  %{buildroot}%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparcv9 ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

find %{buildroot} -name \*.la | xargs rm -f
%if %{build_java}
# gcj -static doesn't work properly anyway, unless using --whole-archive
# and saving 35MB is not bad.
find %{buildroot} -name libgcj.a -o -name libgtkpeer.a \
		     -o -name libgjsmalsa.a -o -name libgcj-tools.a -o -name libjvm.a \
		     -o -name libgij.a -o -name libgcj_bc.a -o -name libjavamath.a \
  | xargs rm -f

mv %{buildroot}%{_prefix}/lib/libgcj.spec $FULLPATH/
sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/' \
  $FULLPATH/libgcj.spec
%endif

mkdir -p %{buildroot}/%{_lib}
mv -f %{buildroot}%{_prefix}/%{_lib}/libgcc_s.so.1 %{buildroot}/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 %{buildroot}/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 %{buildroot}/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparcv9 ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/64/libgcc_s.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/32/libgcc_s.so
%endif
%ifarch ppc
rm -f $FULLPATH/libgcc_s.so
echo '/* GNU ld script
   Use the shared library, but some functions are only in
   the static library, so try that secondarily.  */
OUTPUT_FORMAT(elf32-powerpc)
GROUP ( /lib/libgcc_s.so.1 libgcc.a )' > $FULLPATH/libgcc_s.so
%endif
%ifarch ppc64
rm -f $FULLPATH/32/libgcc_s.so
echo '/* GNU ld script
   Use the shared library, but some functions are only in
   the static library, so try that secondarily.  */
OUTPUT_FORMAT(elf32-powerpc)
GROUP ( /lib/libgcc_s.so.1 libgcc.a )' > $FULLPATH/32/libgcc_s.so
%endif

mv -f %{buildroot}%{_prefix}/%{_lib}/libgomp.spec $FULLPATH/

%if %{build_ada}
mv -f $FULLPATH/adalib/libgnarl-*.so %{buildroot}%{_prefix}/%{_lib}/
mv -f $FULLPATH/adalib/libgnat-*.so %{buildroot}%{_prefix}/%{_lib}/
rm -f $FULLPATH/adalib/libgnarl.so* $FULLPATH/adalib/libgnat.so*
%endif

mkdir -p %{buildroot}%{_prefix}/libexec/getconf
if gcc/xgcc -B gcc/ -E -dD -xc /dev/null | grep __LONG_MAX__.*2147483647; then
  ln -sf POSIX_V6_ILP32_OFF32 %{buildroot}%{_prefix}/libexec/getconf/default
else
  ln -sf POSIX_V6_LP64_OFF64 %{buildroot}%{_prefix}/libexec/getconf/default
fi

%if %{build_java}
if [ "%{_lib}" != "lib" ]; then
  mkdir -p %{buildroot}%{_prefix}/%{_lib}/pkgconfig
  sed '/^libdir/s/lib$/%{_lib}/' %{buildroot}%{_prefix}/lib/pkgconfig/libgcj-*.pc \
    > %{buildroot}%{_prefix}/%{_lib}/pkgconfig/`basename %{buildroot}%{_prefix}/lib/pkgconfig/libgcj-*.pc`
fi
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.2 libobjc.so
ln -sf ../../../libstdc++.so.6.* libstdc++.so
ln -sf ../../../libgfortran.so.3.* libgfortran.so
ln -sf ../../../libgomp.so.1.* libgomp.so
ln -sf ../../../libmudflap.so.0.* libmudflap.so
ln -sf ../../../libmudflapth.so.0.* libmudflapth.so
%if %{build_java}
ln -sf ../../../libgcj.so.10.* libgcj.so
ln -sf ../../../libgcj-tools.so.10.* libgcj-tools.so
ln -sf ../../../libgij.so.10.* libgij.so
%endif
else
ln -sf ../../../../%{_lib}/libobjc.so.2 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.6.* libstdc++.so
ln -sf ../../../../%{_lib}/libgfortran.so.3.* libgfortran.so
ln -sf ../../../../%{_lib}/libgomp.so.1.* libgomp.so
ln -sf ../../../../%{_lib}/libmudflap.so.0.* libmudflap.so
ln -sf ../../../../%{_lib}/libmudflapth.so.0.* libmudflapth.so
%if %{build_java}
ln -sf ../../../../%{_lib}/libgcj.so.10.* libgcj.so
ln -sf ../../../../%{_lib}/libgcj-tools.so.10.* libgcj-tools.so
ln -sf ../../../../%{_lib}/libgij.so.10.* libgij.so
%endif
fi
%if %{build_java}
mv -f %{buildroot}%{_prefix}/%{_lib}/libgcj_bc.so $FULLLPATH/
%endif
mv -f %{buildroot}%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f %{buildroot}%{_prefix}/%{_lib}/libsupc++.*a .
mv -f %{buildroot}%{_prefix}/%{_lib}/libgfortran.*a .
mv -f %{buildroot}%{_prefix}/%{_lib}/libobjc.*a .
mv -f %{buildroot}%{_prefix}/%{_lib}/libgomp.*a .
mv -f %{buildroot}%{_prefix}/%{_lib}/libmudflap{,th}.*a $FULLLPATH/

%if %{build_ada}
%ifarch sparcv9 ppc
rm -rf $FULLPATH/64/ada{include,lib}
%endif
%ifarch %{multilib_64_archs}
rm -rf $FULLPATH/32/ada{include,lib}
%endif
if [ "$FULLPATH" != "$FULLLPATH" ]; then
mv -f $FULLPATH/ada{include,lib} $FULLLPATH/
pushd $FULLLPATH/adalib
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../../../libgnarl-*.so libgnarl.so
ln -sf ../../../../../libgnarl-*.so libgnarl-4.4.so
ln -sf ../../../../../libgnat-*.so libgnat.so
ln -sf ../../../../../libgnat-*.so libgnat-4.4.so
else
ln -sf ../../../../../../%{_lib}/libgnarl-*.so libgnarl.so
ln -sf ../../../../../../%{_lib}/libgnarl-*.so libgnarl-4.4.so
ln -sf ../../../../../../%{_lib}/libgnat-*.so libgnat.so
ln -sf ../../../../../../%{_lib}/libgnat-*.so libgnat-4.4.so
fi
popd
else
pushd $FULLPATH/adalib
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../../libgnarl-*.so libgnarl.so
ln -sf ../../../../libgnarl-*.so libgnarl-4.4.so
ln -sf ../../../../libgnat-*.so libgnat.so
ln -sf ../../../../libgnat-*.so libgnat-4.4.so
else
ln -sf ../../../../../%{_lib}/libgnarl-*.so libgnarl.so
ln -sf ../../../../../%{_lib}/libgnarl-*.so libgnarl-4.4.so
ln -sf ../../../../../%{_lib}/libgnat-*.so libgnat.so
ln -sf ../../../../../%{_lib}/libgnat-*.so libgnat-4.4.so
fi
popd
fi
%endif

%ifarch sparcv9 ppc
ln -sf ../../../../../lib64/libobjc.so.2 64/libobjc.so
ln -sf ../`echo ../../../../lib/libstdc++.so.6.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
ln -sf ../`echo ../../../../lib/libgfortran.so.3.* | sed s~/lib/~/lib64/~` 64/libgfortran.so
ln -sf ../`echo ../../../../lib/libgomp.so.1.* | sed s~/lib/~/lib64/~` 64/libgomp.so
rm -f libmudflap.so libmudflapth.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflap.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflapth.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > 64/libmudflap.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > 64/libmudflapth.so
%if %{build_java}
ln -sf ../`echo ../../../../lib/libgcj.so.10.* | sed s~/lib/~/lib64/~` 64/libgcj.so
ln -sf ../`echo ../../../../lib/libgcj-tools.so.10.* | sed s~/lib/~/lib64/~` 64/libgcj-tools.so
ln -sf ../`echo ../../../../lib/libgij.so.10.* | sed s~/lib/~/lib64/~` 64/libgij.so
ln -sf lib32/libgcj_bc.so libgcj_bc.so
ln -sf ../lib64/libgcj_bc.so 64/libgcj_bc.so
%endif
mv -f %{buildroot}%{_prefix}/lib64/libsupc++.*a 64/
mv -f %{buildroot}%{_prefix}/lib64/libgfortran.*a 64/
mv -f %{buildroot}%{_prefix}/lib64/libobjc.*a 64/
mv -f %{buildroot}%{_prefix}/lib64/libgomp.*a 64/
ln -sf lib32/libstdc++.a libstdc++.a
ln -sf ../lib64/libstdc++.a 64/libstdc++.a
ln -sf lib32/libmudflap.a libmudflap.a
ln -sf ../lib64/libmudflap.a 64/libmudflap.a
ln -sf lib32/libmudflapth.a libmudflapth.a
ln -sf ../lib64/libmudflapth.a 64/libmudflapth.a
%if %{build_ada}
ln -sf lib32/adainclude adainclude
ln -sf ../lib64/adainclude 64/adainclude
ln -sf lib32/adalib adalib
ln -sf ../lib64/adalib 64/adalib
%endif
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../../../../libobjc.so.2 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.6.* | sed s~/../lib64/~/~` 32/libstdc++.so
ln -sf ../`echo ../../../../lib64/libgfortran.so.3.* | sed s~/../lib64/~/~` 32/libgfortran.so
ln -sf ../`echo ../../../../lib64/libgomp.so.1.* | sed s~/../lib64/~/~` 32/libgomp.so
rm -f libmudflap.so libmudflapth.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib64/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflap.so
echo 'INPUT ( %{_prefix}/lib64/'`echo ../../../../lib64/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > libmudflapth.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib64/libmudflap.so.0.* | sed 's,^.*libm,libm,'`' )' > 32/libmudflap.so
echo 'INPUT ( %{_prefix}/lib/'`echo ../../../../lib64/libmudflapth.so.0.* | sed 's,^.*libm,libm,'`' )' > 32/libmudflapth.so
%if %{build_java}
ln -sf ../`echo ../../../../lib64/libgcj.so.10.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/libgcj-tools.so.10.* | sed s~/../lib64/~/~` 32/libgcj-tools.so
ln -sf ../`echo ../../../../lib64/libgij.so.10.* | sed s~/../lib64/~/~` 32/libgij.so
%endif
mv -f %{buildroot}%{_prefix}/lib/libsupc++.*a 32/
mv -f %{buildroot}%{_prefix}/lib/libgfortran.*a 32/
mv -f %{buildroot}%{_prefix}/lib/libobjc.*a 32/
mv -f %{buildroot}%{_prefix}/lib/libgomp.*a 32/
%endif
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
ln -sf ../lib32/libmudflap.a 32/libmudflap.a
ln -sf lib64/libmudflap.a libmudflap.a
ln -sf ../lib32/libmudflapth.a 32/libmudflapth.a
ln -sf lib64/libmudflapth.a libmudflapth.a
%if %{build_java}
ln -sf ../lib32/libgcj_bc.so 32/libgcj_bc.so
ln -sf lib64/libgcj_bc.so libgcj_bc.so
%endif
%if %{build_ada}
ln -sf ../lib32/adainclude 32/adainclude
ln -sf lib64/adainclude adainclude
ln -sf ../lib32/adalib 32/adalib
ln -sf lib64/adalib adalib
%endif
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libmudflap.a 32/libmudflap.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libmudflapth.a 32/libmudflapth.a
%if %{build_java}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj_bc.so 32/libgcj_bc.so
%endif
%if %{build_ada}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/adainclude 32/adainclude
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/adalib 32/adalib
%endif
%endif
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libgfortran.a -o -name libobjc.a -o -name libgomp.a \
		    -o -name libmudflap.a -o -name libmudflapth.a \
		    -o -name libgcc.a -o -name libgcov.a \) -a -type f`
popd
chmod 755 %{buildroot}%{_prefix}/%{_lib}/libgfortran.so.3.*
chmod 755 %{buildroot}%{_prefix}/%{_lib}/libgomp.so.1.*
chmod 755 %{buildroot}%{_prefix}/%{_lib}/libmudflap{,th}.so.0.*
chmod 755 %{buildroot}%{_prefix}/%{_lib}/libobjc.so.2.*

%if %{build_ada}
chmod 755 %{buildroot}%{_prefix}/%{_lib}/libgnarl*so*
chmod 755 %{buildroot}%{_prefix}/%{_lib}/libgnat*so*
%endif

mv $FULLPATH/include-fixed/syslimits.h $FULLPATH/include/syslimits.h
mv $FULLPATH/include-fixed/limits.h $FULLPATH/include/limits.h
for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > %{buildroot}%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec gcc $fl ${1+"$@"}
EOF
cat > %{buildroot}%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec gcc $fl ${1+"$@"}
EOF
chmod 755 %{buildroot}%{_prefix}/bin/c?9

mkdir -p %{buildroot}%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o %{buildroot}%{_prefix}/sbin/libgcc_post_upgrade
strip %{buildroot}%{_prefix}/sbin/libgcc_post_upgrade

cd ..
%find_lang %{name}
%find_lang cpplib

# Remove binaries we will not be including, so that they don't end up in
# gcc-debuginfo
rm -f %{buildroot}%{_prefix}/%{_lib}/{libffi*,libiberty.a}
rm -f $FULLEPATH/install-tools/{mkheaders,fixincl}
rm -f %{buildroot}%{_prefix}/lib/{32,64}/libiberty.a
rm -f %{buildroot}%{_prefix}/%{_lib}/libssp*
rm -f %{buildroot}%{_prefix}/bin/gnative2ascii

%ifarch %{multilib_64_archs}
# Remove libraries for the other arch on multilib arches
rm -f %{buildroot}%{_prefix}/lib/lib*.so*
rm -f %{buildroot}%{_prefix}/lib/lib*.a
%else
%ifarch sparcv9 ppc
rm -f %{buildroot}%{_prefix}/lib64/lib*.so*
rm -f %{buildroot}%{_prefix}/lib64/lib*.a
%endif
%endif

%if %{build_java}
mkdir -p %{buildroot}%{_prefix}/share/java/gcj-endorsed \
	 %{buildroot}%{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d
chmod 755 %{buildroot}%{_prefix}/share/java/gcj-endorsed \
	  %{buildroot}%{_prefix}/%{_lib}/gcj-%{version} \
	  %{buildroot}%{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d
touch %{buildroot}%{_prefix}/%{_lib}/gcj-%{version}/classmap.db
%endif

install -m644 %{SOURCE3} %{buildroot}%{_mandir}/man1/protoize.1
echo '.so man1/protoize.1' > %{buildroot}%{_mandir}/man1/unprotoize.1
chmod 644 %{buildroot}%{_mandir}/man1/unprotoize.1

#%%if #%%{with do_test}
%if %{do_test}
%check
cd obj-%{gcc_target_platform}

# run the tests.
make %{?_smp_mflags} -k check ALT_CC_UNDER_TEST=gcc ALT_CXX_UNDER_TEST=g++ RUNTESTFLAGS="--target_board=unix/'{,-fstack-protector}'" || :
echo ====================TESTING=========================
( LC_ALL=C ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
echo ====================TESTING END=====================
%if 0
mkdir testlogs-%{_target_platform}-%{version}-%{release}
for i in `find . -name \*.log | grep -F testsuite/ | grep -v 'config.log\|acats.*/tests/'`; do
  ln $i testlogs-%{_target_platform}-%{version}-%{release}/ || :
done
tar cf - testlogs-%{_target_platform}-%{version}-%{release} | bzip2 -9c \
  | uuencode testlogs-%{_target_platform}.tar.bz2 || :
rm -rf testlogs-%{_target_platform}-%{version}-%{release}
%endif
%endif

%clean
rm -rf %{buildroot}

%post
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcc.info || :

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcc.info || :
fi

%post -n cpp
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cpp.info || :

%preun -n cpp
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cpp.info || :
fi

%post gfortran
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gfortran.info || :

%preun gfortran
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gfortran.info || :
fi

%post java
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcj.info || :

%preun java
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcj.info || :
fi

%post gnat
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_rm.info || :
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_ugn.info || :
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat-style.info || :

%preun gnat
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_rm.info || :
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_ugn.info || :
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat-style.info || :
fi

# Because glibc Prereq's libgcc and /sbin/ldconfig
# comes from glibc, it might not exist yet when
# libgcc is installed
%post -n libgcc -p %{_prefix}/sbin/libgcc_post_upgrade

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%post -n libobjc -p /sbin/ldconfig

%postun -n libobjc -p /sbin/ldconfig

%post -n libgcj
/sbin/ldconfig
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cp-tools.info || :

%preun -n libgcj
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cp-tools.info || :
fi

%postun -n libgcj -p /sbin/ldconfig

%post -n libgfortran -p /sbin/ldconfig

%postun -n libgfortran -p /sbin/ldconfig

%post -n libgnat -p /sbin/ldconfig

%postun -n libgnat -p /sbin/ldconfig

%post -n libgomp
/sbin/ldconfig
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/libgomp.info || :

%preun -n libgomp
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/libgomp.info || :
fi

%postun -n libgomp -p /sbin/ldconfig

%post -n libmudflap -p /sbin/ldconfig

%postun -n libmudflap -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-,root,root,-)
%{_prefix}/bin/cc
%{_prefix}/bin/c89
%{_prefix}/bin/c99
%{_prefix}/bin/gcc
%{_prefix}/bin/gcov
%{_prefix}/bin/protoize
%{_prefix}/bin/unprotoize
%ifarch ppc
%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc64 sparcv9
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc
%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
%{_mandir}/man1/protoize.1*
%{_mandir}/man1/unprotoize.1*
%{_infodir}/gcc*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/SYSCALLS.c.X
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdfix.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/omp.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/tmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ammintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/smmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/nmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/bmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/wmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/immintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/avxintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/x86intrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/fma4intrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xopintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/lwpintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/abmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/popcntintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm_malloc.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm3dnow.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/cpuid.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/cross-stdarg.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spe.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/paired.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppu_intrinsics.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/si2vmx.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spu2vmx.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/vec_types.h
%endif
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.spec
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgomp.so
%ifarch sparcv9 ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgomp.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_s.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgomp.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgomp.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.so
%endif
%ifarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.so
%endif
#%%dir %{_prefix}/libexec/getconf
%{_prefix}/libexec/getconf/default
%doc gcc/README* rpm.doc/changelogs/gcc/ChangeLog* gcc/COPYING*

%files -n cpp -f cpplib.lang
%defattr(-,root,root,-)
/lib/cpp
%{_prefix}/bin/cpp
%{_mandir}/man1/cpp.1*
%{_infodir}/cpp*
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1

%files -n libgcc
%defattr(-,root,root,-)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1
%{_prefix}/sbin/libgcc_post_upgrade
%doc gcc/COPYING.LIB

%files c++
%defattr(-,root,root,-)
%{_prefix}/bin/%{gcc_target_platform}-*++
%{_prefix}/bin/g++
%{_prefix}/bin/c++
%{_mandir}/man1/g++.1*
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%ifarch sparcv9 ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%ifarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%doc rpm.doc/changelogs/gcc/cp/ChangeLog*

%files -n libstdc++
%defattr(-,root,root,-)
%{_prefix}/%{_lib}/libstdc++.so.6*

%files -n libstdc++-devel
%defattr(-,root,root,-)
%dir %{_prefix}/include/c++
%dir %{_prefix}/include/c++/%{gcc_version}
%{_prefix}/include/c++/%{gcc_version}/[^gjos]*
%{_prefix}/include/c++/%{gcc_version}/os*
%{_prefix}/include/c++/%{gcc_version}/s[^u]*
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif
%ifarch sparc64 ppc64
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif
%ifnarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%ifnarch sparcv9 ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%doc rpm.doc/changelogs/libstdc++-v3/ChangeLog* libstdc++-v3/README*

%if %{build_libstdcxx_docs}
%files -n libstdc++-docs
%defattr(-,root,root)
%{_mandir}/man3/*
%doc rpm.doc/libstdc++-v3/html
%endif

%files objc
%defattr(-,root,root,-)
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libobjc.so
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libobjc.so
%endif
%ifarch %{multilib_64_archs}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif
%doc rpm.doc/objc/*
%doc libobjc/THREADS* rpm.doc/changelogs/libobjc/ChangeLog*

%files objc++
%defattr(-,root,root,-)
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1objplus

%files -n libobjc
%defattr(-,root,root,-)
%{_prefix}/%{_lib}/libobjc.so.2*

%files gfortran
%defattr(-,root,root,-)
%{_prefix}/bin/gfortran
%{_prefix}/bin/f95
%{_mandir}/man1/gfortran.1*
%{_infodir}/gfortran*
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.f90
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib.mod
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/finclude/omp_lib_kinds.mod
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/f951
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortran.so
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortran.so
%endif
%ifarch %{multilib_64_archs}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortran.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortran.so
%endif
%doc rpm.doc/gfortran/*

%files -n libgfortran
%defattr(-,root,root,-)
%{_prefix}/%{_lib}/libgfortran.so.3*

%if %{build_java}
%files java
%defattr(-,root,root,-)
%{_prefix}/bin/gcj
%{_prefix}/bin/gjavah
%{_prefix}/bin/gcjh
%{_prefix}/bin/jcf-dump
%{_mandir}/man1/gcj.1*
%{_mandir}/man1/jcf-dump.1*
%{_mandir}/man1/gjavah.1*
%{_mandir}/man1/gcjh.1*
%{_infodir}/gcj*
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/ecj1
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj-tools.so
%ifarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj_bc.so
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgij.so
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj-tools.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj_bc.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgij.so
%endif
%ifarch %{multilib_64_archs}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj-tools.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj_bc.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgij.so
%endif
%doc rpm.doc/changelogs/gcc/java/ChangeLog*

%files -n libgcj
%defattr(-,root,root,-)
%{_prefix}/bin/jv-convert
%{_prefix}/bin/gij
%{_prefix}/bin/gjar
%{_prefix}/bin/grmic
%{_prefix}/bin/grmid
%{_prefix}/bin/grmiregistry
%{_prefix}/bin/gtnameserv
%{_prefix}/bin/gkeytool
%{_prefix}/bin/gorbd
%{_prefix}/bin/gserialver
%{_prefix}/bin/gcj-dbtool
%if %{include_gappletviewer}
%{_prefix}/bin/gappletviewer
%{_mandir}/man1/gappletviewer.1*
%endif
%{_prefix}/bin/gjarsigner
%{_mandir}/man1/gjar.1*
%{_mandir}/man1/gjarsigner.1*
%{_mandir}/man1/jv-convert.1*
%{_mandir}/man1/gij.1*
%{_mandir}/man1/grmic.1*
%{_mandir}/man1/grmiregistry.1*
%{_mandir}/man1/gcj-dbtool.1*
%{_mandir}/man1/gkeytool.1*
%{_mandir}/man1/gorbd.1*
%{_mandir}/man1/grmid.1*
%{_mandir}/man1/gserialver.1*
%{_mandir}/man1/gtnameserv.1*
%{_infodir}/cp-tools.info*
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/%{_lib}/libgcj-tools.so.*
%{_prefix}/%{_lib}/libgcj_bc.so.*
%{_prefix}/%{_lib}/libgij.so.*
%dir %{_prefix}/%{_lib}/gcj-%{version}
%{_prefix}/%{_lib}/gcj-%{version}/libgtkpeer.so
%{_prefix}/%{_lib}/gcj-%{version}/libgjsmalsa.so
%{_prefix}/%{_lib}/gcj-%{version}/libjawt.so
%if %{include_gappletviewer}
%{_prefix}/%{_lib}/gcj-%{version}/libgcjwebplugin.so
%endif
%{_prefix}/%{_lib}/gcj-%{version}/libjvm.so
%{_prefix}/%{_lib}/gcj-%{version}/libjavamath.so
#%%dir %{_prefix}/share/java
%{_prefix}/share/java/[^sl]*
%{_prefix}/share/java/libgcj-%{version}.jar
%dir %{_prefix}/%{_lib}/security
%config(noreplace) %{_prefix}/%{_lib}/security/classpath.security
%{_prefix}/%{_lib}/logging.properties
%dir %{_prefix}/%{_lib}/gcj-%{version}/classmap.db.d
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) %{_prefix}/%{_lib}/gcj-%{version}/classmap.db
%if %{include_gappletviewer}
%doc rpm.doc/README.libgcjwebplugin.so
%endif

%files -n libgcj-devel
%defattr(-,root,root,-)
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gcj
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jawt.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jawt_md.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jni.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jni_md.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jvmpi.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj_bc.so
%endif
%ifarch sparc64 ppc64
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libgcj_bc.so
%endif
%ifnarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj_bc.so
%endif
#%%dir %{_prefix}/include/c++
#%%dir %{_prefix}/include/c++/%{gcc_version}
%{_prefix}/include/c++/%{gcc_version}/[gj]*
%{_prefix}/include/c++/%{gcc_version}/org
%{_prefix}/include/c++/%{gcc_version}/sun
%{_prefix}/%{_lib}/pkgconfig/libgcj-*.pc
%doc rpm.doc/boehm-gc/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*

%files -n libgcj-src
%defattr(-,root,root,-)
#%%dir %{_prefix}/share/java
%{_prefix}/share/java/src*.zip
%{_prefix}/share/java/libgcj-tools-%{version}.jar
%endif

%if %{build_ada}
%files gnat
%defattr(-,root,root,-)
%{_prefix}/bin/gnat*
%{_infodir}/gnat*
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/libexec/gcc
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/adalib
%endif
%ifarch %{multilib_64_archs}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/adalib
%endif
%ifarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/adalib
%endif
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/gnat1
%doc rpm.doc/changelogs/gcc/ada/ChangeLog*

%files -n libgnat
%defattr(-,root,root,-)
%{_prefix}/%{_lib}/libgnat-*.so
%{_prefix}/%{_lib}/libgnarl-*.so

%files -n libgnat-devel
%defattr(-,root,root,-)
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/adalib
%endif
%ifarch sparc64 ppc64
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/adalib
%endif
%ifnarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/adainclude
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/adalib
%endif
%endif

%files -n libgomp
%defattr(-,root,root,-)
%{_prefix}/%{_lib}/libgomp.so.1*
%{_infodir}/libgomp.info*
%doc rpm.doc/changelogs/libgomp/ChangeLog*

%files -n libmudflap
%defattr(-,root,root,-)
%{_prefix}/%{_lib}/libmudflap.so.0*
%{_prefix}/%{_lib}/libmudflapth.so.0*

%files -n libmudflap-devel
%defattr(-,root,root,-)
#%%dir %{_prefix}/lib/gcc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mf-runtime.h
%ifarch sparcv9 ppc
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libmudflapth.a
%endif
%ifarch sparc64 ppc64
#%%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libmudflapth.a
%endif
%ifnarch sparcv9 sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.so
%endif
%doc rpm.doc/changelogs/libmudflap/ChangeLog*

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (4.4.4-3m)
- full rebuild for mo7 release

* Wed Jul  7 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.4.4-2m)
- merge from Fedora 13 (4.4.4-10)

* Sat May  1 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.4.4-1m)
- merge from Fedora 13 (4.4.4-1)
- explicit BuildRequires: glibc-static

* Sun Apr 11 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (4.4.3-6m)
-- merge from Fedora-rawhide (4.4.3-16)

* Sun Mar 14 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.4.3-5m)
- rebuild against glibc-2.11.90

* Tue Feb  2 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.4.3-4m)
- set specopt "do_test" again

* Mon Feb  1 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.4.3-3m)
- grip abmintrin.h and popcntintrin.h

* Wed Jan 27 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.4.3-2m)
- set include_gappletviewer to 0 for xulrunner-1.9.2

* Tue Jan 26 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.4.3-1m)
- [SECURITY] CVE-2009-3736
- update 4.4.3
-- merge from Fedora-rawhide (4.4.3-2)

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.4.2-4m)
- merge from T4R
-- * Wed Nov 11 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.2-3m)
-- - sync with Fedora 12
-- -- * Mon Nov  9 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-9
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/35067, c++/36912, c++/36959, c++/37093, c++/38699, c++/39786,
-- -- 	c++/41856, c++/41876, c++/41967, c++/9381, fortran/41772,
-- -- 	fortran/41909, middle-end/41963, rtl-optimization/41917,
-- -- 	target/41900, tree-optimization/41643
-- -- - selected backports from trunk
-- --   - PRs debug/41801, middle-end/41837, target/41985, tree-optimization/41841
-- -- - initial AMD Orochi -mxop and -mlwp support
-- -- - try to avoid wrapping CONST_INTs/VOIDmode CONST_DOUBLEs into CONST
-- 
-- * Tue Nov  3 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.2-2m)
-- - sync with Fedora 12
-- -- * Mon Nov  2 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-8
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/41754, fortran/41777, fortran/41850, libstdc++/40852
-- -- - fix ICE with unmatched #pragma GCC visibility push/pop (PR c++/41774)
-- -- - fix VTA ICE with -combine (#531385, PR debug/41893)
-- -- - fix RTTI for anon namespace classes
-- -- - fix incorrect uses of __restrict keyword in valarray (PR libstdc++/41763)
-- -- 
-- -- * Tue Oct 27 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-7
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/40808, c/41842, cp-tools/39177
-- -- - VTA backports
-- --   - PR bootstrap/41345
-- -- - don't emit DW_AT_name: <anonymous struct> etc. into debug info
-- --   (#530304, PR debug/41828)
-- -- - power7 ABI fixes (PR target/41787)
-- -- - fix ICE in ix86_pic_register_p (PR target/41762)
-- -- 
-- -- * Thu Oct 22 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-6
-- -- - update from gcc-4_4-branch
-- --   - PR target/41702
-- --   - fix a pod2man error in gcc.1 (#530102)
-- --   - fix mangling of very large names
-- -- - document -print-multi-os-directory in gcc.info and gcc.1
-- --   (#529659, PR other/25507)
-- 
-- * Tue Oct 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.2-1m)
-- - sync with Fedora 12
-- -- * Mon Oct 19 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-5
-- -- - update from gcc-4_4-branch
-- --   - PR fortran/41755
-- --   - s390 z10 tuning fixes
-- -- - provide accurate attributes for powerpc builtins (PR target/23983)
-- -- - fix -fcompare-debug differences caused by DCE removal of debug stmts
-- -- - fix updating of speculation status with VTA (PR debug/41739)
-- -- 
-- -- * Sun Oct 18 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-4
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/37204, c++/37766, c++/37875, c++/38798, c++/40092,
-- -- 	libstdc++/40654, libstdc++/40826
-- -- - fix VTA ICE on invalid pointer arithmetics (#529512)
-- -- 
-- -- * Sat Oct 17 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-3
-- -- - fix VTA handling in the scheduler (PR debug/41535)
-- -- - fix up %%check section to be able to find ecj1
-- -- 
-- -- * Fri Oct 16 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-2
-- -- - update from gcc-4_4-branch
-- --   - PR target/40913
-- -- - VTA backports
-- --   - PR debug/41717
-- -- - fix Ada .eh_frame generation (PR debug/40521)
-- -- 
-- -- * Thu Oct 15 2009 Jakub Jelinek <jakub@redhat.com> 4.4.2-1
-- -- - update from gcc-4_4-branch
-- --   - GCC 4.4.2 release
-- --   - PRs middle-end/22072, target/41665
-- -- - don't emit -Wpadded warnings for builtin structures
-- -- - don't generate .eh_frame, but generate .debug_frame when -g and none of
-- --   -fasynchronous-unwind-tables/-fexceptions/-funwind-tables is used
-- --   (PR debug/40521)
-- -- 
-- -- * Wed Oct 14 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-22
-- -- - update from gcc-4_4-branch
-- --   - PRs target/26515, target/38948
-- --   - fix s390{,x} BLKmode symbol handling
-- --   - fix i?86 testqi splitter (#528206, PR target/41680)
-- -- - VTA backports
-- --   - introduce debug temps (PRs debug/41264, debug/41338, debug/41343,
-- --     debug/41447, target/41693)
-- --   - build debug stmts on updates (PR debug/41616)
-- --   - fix another with/without -save-temps debug info difference
-- --     (#526841, PR preprocessor/41543)
-- --   - fix invalid ranges in .debug_loc section (PR debug/41695)
-- -- - if -mcpu= isn't specified, default to -mcpu=power4 (#463549)
-- -- 
-- -- * Sat Oct 10 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-21
-- -- - update from gcc-4_4-branch
-- --   - fix s390{,x} prefetch for pre-z10 CPUs (#524552)
-- -- - VTA backports
-- --   - fix debug info differences with/without -save-temps
-- --     (PR preprocessor/41445)
-- -- - fix ICE with small BLKmode returning call (#516028,
-- --   PR rtl-optimization/41646)
-- -- 
-- -- * Thu Oct  8 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-20
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/39863, c++/41038
-- -- - avoid redundant DW_AT_const_value when abstract origin already has one
-- --   (#527430) 
-- -- - another VTA debug stmt renaming bugfix (#521991)
-- -- 
-- -- * Mon Oct  5 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-19
-- -- - update from gcc-4_4-branch
-- --   - PRs fortran/41479, fortran/41515
-- -- - VTA backports
-- --   - PRs debug/41353, debug/41404, rtl-optimization/41511
-- --   - another debug info fix for decls passed by reference (#527057,
-- --     PR debug/41558)
-- --   - don't emit DW_AT_name on DW_TAG_const_type (#526970)
-- -- - avoid invalid folding of casts to addresses of first fields
-- --   (#527121, PR middle-end/41317)
-- 
-- * Sat Oct 10 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-8m)
-- - sync with Rawhide
-- -- * Thu Oct  1 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-18
-- -- - update from gcc-4_4-branch
-- --   - PRs ada/41100, target/22093
-- -- - VTA backports
-- --   - PRs debug/41438, debug/41474, target/41279, testsuite/41444
-- -- - fix VTA ICE on Linux kernel (#521991)
-- -- - AMD Orochi -mfma4 support
-- -- - don't run install-info if info files are missing because of --excludedocs
-- --   (#515921, #515960, #515962, #515965, #516000, #516008, #516014)
-- 
-- * Sun Oct  4 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-7m)
-- - fix %%files
-- - fix Requires
-- - add Provides: /usr/sbin/libgcc_post_upgrade
-- 
-- * Thu Oct  1 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-6m)
-- - separate out fastjar to avoid conflicts with T4R/gcc-test
-- 
-- * Sat Sep 26 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-5m)
-- - sync with Rawhide
-- -- * Fri Sep 25 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-17
-- -- - update from gcc-4_4-branch
-- --   - fix vectorizer for power7 (#463846)
-- -- - VTA backports
-- --   - fix debug info for parameters passed by reference (#525709)
-- --   - PR bootstrap/41457
-- -- - remove power7 VSX load/store with update insn support
-- -- - remove SSE5 support
-- -- 
-- -- * Wed Sep 23 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-16
-- -- - update from gcc-4_4-branch
-- --   - PRs c/39779, c/41049, debug/41065, libffi/40242, libffi/41443,
-- -- 	libgfortran/41328, testsuite/41288
-- -- - VTA backports
-- --   - PRs bootstrap/41397, bootstrap/41404, bootstrap/41405, debug/41295,
-- -- 	debug/41411, debug/41439
-- --   - fix ICE caused by reload substitution of const_int into zero_extend
-- --     in debug_insn (#524439)
-- -- - fix altivec vec_cmp{lt,gt} (#524273)
-- -- - fix -mno-sched-epilogue on ppc (#524216, PR target/40473)
-- -- - don't look at MUDFLAP_OPTIONS env var in suid/sgid programs
-- --   (PR libmudflap/41433)
-- 
-- * Sat Sep 19 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-4m)
-- - sync with Rawhide
-- -- * Fri Sep 18 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-15
-- -- - for now disable out of line gpr/fpr saving on ppc with -m64 -Os -mcall-aixdesc
-- -- - fix DW_AT_decl_{file,location} for DW_TAG_structure_type for C structs
-- --   with forward declarations (#523810)
-- -- 
-- -- * Wed Sep 16 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-14
-- -- - update from gcc-4_4-branch
-- --   - PRs fortran/39876, tree-optimization/41101
-- -- - asm goto support
-- -- - VTA delayed branch scheduling fix (PR bootstrap/41349)
-- -- - power7 VSX fix (PR target/41210)
-- -- - ppc bswap fixes (PR target/41331)
-- -- 
-- -- * Fri Sep 11 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-13
-- -- - fix ICE in debuginfo output with BLOCK_NONLOCALIZED_VARS (#518303)
-- -- - wrap_constant when propagating for subst in debug in the combiner (#522577)
-- -- - further fix for ppc -m32 -Os out of line gpr/fpr restoring (PR target/41175)
-- -- 
-- -- * Thu Sep 10 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-12
-- -- - update from gcc-4_4-branch
-- --   - PRs bootstrap/41180, target/41315
-- -- - fix ICE in tree-ssa-phiprop.c (#522277, PR tree-optimization/39827)
-- -- - ppc64 bswap fix
-- -- - fix ppc/ppc64 -mmultiple and out of line gpr/fpr saving bugs
-- --   (#519409, PR target/40677, PR target/41175)
-- -- 
-- -- * Wed Sep  9 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-11
-- -- - fix ICE in tls_mem_loc_descriptor (#521991)
-- -- 
-- -- * Tue Sep  8 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-10
-- -- - update from gcc-4_4-branch
-- --   - PRs fortran/41258, rtl-optimization/40861
-- -- - fix scheduler not to reorder potentially trapping insns across
-- --   calls that might not always return (#520916, PR rtl-optimization/41239)
-- -- - merge in VTA
-- 
-- * Sun Sep  6 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-3m)
-- - sync with Rawhide
-- -- merged unique-object patch
-- -- 
-- -- * Thu Sep  3 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-9
-- -- - update from gcc-4_4-branch
-- --   - fix wide char constant stringification
-- -- - __builtin_unreachable fix
-- -- 
-- -- * Wed Sep  2 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-8
-- -- - fix up __builtin_object_size (#505862)
-- -- - fix Fortran GOTO warning (PR fortran/38507)
-- -- 
-- -- * Tue Sep  1 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-7
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/41120, c++/41127, c++/41131, fortran/41062, fortran/41102,
-- -- 	fortran/41121, fortran/41126, fortran/41139, fortran/41157,
-- -- 	fortran/41162, libfortran/40962, libstdc++/41005, middle-end/41094,
-- -- 	middle-end/41123, middle-end/41163, target/34412, target/40718
-- -- - fix pr22033.C on ppc*/ia64/sparc*
-- -- - emit namespace DIE even if it contains just some used type (PR debug/41170)
-- -- - fix dynamic_cast (#519517)
-- -- - backport power7 changes from the trunk, instead of using the old incomplete
-- --   backport from ibm/power7-meissner
-- 
-- * Sat Sep  5 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-2m)
-- - %%bcond_without unique_object
-- - %%bcond_with ada
-- - %%bcond_without do_test
-- - enable %%check, but disable archiving testlogs
-- 
-- * Fri Aug 28 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.1-1m)
-- - ***DO NOT TRY THIS***
-- - switch to svn redhat/gcc-4_4-branch and momonganize
-- - newer glibc is required
-- - temporarily disable ada
-- - include fastjar
-- - move out libffi* subpackages to libffi.spec
-- - fix install-info
-- - temporarily disable %%check (why annihilation?)
-- - restore %%changelog
-- -- 
-- -- * Tue Aug 18 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-6
-- -- - update from gcc-4_4-branch
-- --   - PRs bootstrap/41018, c/41046, debug/37801, debug/40990, fortran/40847,
-- -- 	rtl-optimization/41033, target/41015, target/41019, target/8603,
-- -- 	tree-optimization/41016
-- -- 
-- -- * Fri Aug  7 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-5
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/40948, target/40906
-- -- - -fexceptions support for -freorder-blocks-and-partition
-- -- 
-- -- * Wed Aug  5 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-4
-- -- - update from gcc-4_4-branch
-- --   - PRs build/40010, c++/39987, c++/40749, c++/40834, c++/40948, debug/39706,
-- -- 	fortran/40822, fortran/40848, fortran/40851, fortran/40878,
-- -- 	libfortran/40853, middle-end/40943, rtl-optimization/40924,
-- -- 	target/40577, testsuite/40829, testsuite/40891,
-- -- 	tree-optimization/40570
-- -- - backport __builtin_unreachable () support
-- -- - fix powerpc ICE in memory_address (#515672, PR target/40971)
-- -- 
-- -- * Sat Jul 25 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-3
-- -- - update from gcc-4_4-branch
-- --   - PR fortran/40727
-- -- - fix unwind info for -freorder-blocks-and-partitions
-- --   (PR rtl-optimization/34999)
-- -- - fix Fortran MINLOC/MAXLOC/MINVAL/MAXVAL handling of infinities and NaNs,
-- --   speed them up (PRs fortran/40643, fortran/31067)
-- -- - fix ICE with Fortran data xfer without io unit (PR fortran/40839)
-- -- 
-- -- * Thu Jul 23 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-2
-- -- - update from gcc-4_4-branch
-- --   - PRs rtl-optimization/40710, target/40832, tree-optimization/40321
-- -- - use STB_GNU_UNIQUE symbols for inline fn local statics and
-- --   template static data members
-- -- - use strcmp for C++ typeinfo comparisons instead of pointer comparison
-- -- 
-- -- * Wed Jul 22 2009 Jakub Jelinek <jakub@redhat.com> 4.4.1-1
-- -- - update from gcc-4_4-branch
-- --   - GCC 4.4.1 release
-- -- 
-- -- * Tue Jul 21 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-15
-- -- - update from gcc-4_4-branch
-- --   - PRs libfortran/40714, target/39943, target/40809, tree-optimization/40792
-- --   - fix ICE in gsi_insert_seq_nodes_after (#505798,
-- --     PR tree-optimization/40813)
-- -- - slightly relax -D_FORTIFY_SOURCE=2 rules for flexible-array-member like
-- --   constructs (#512689, #511573)
-- -- - vectorize unsigned int -> {float,double} conversions on x86/x86_64
-- --   (PR target/40811)
-- -- - update for i586.rpm -> i686.rpm switch (default to -march=i686 -mtune=generic
-- --   in i686.rpm gcc and also with -m32 in x86_64.rpm gcc)
-- -- 
-- -- * Fri Jul 17 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-14
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/40740, libstdc++/40691, middle-end/40747
-- --   - fix ICE in gimplify_conversion (#511229, PR c++/40780)
-- -- 
-- -- * Mon Jul 13 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-13
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/36628, c++/37206, c++/40502, c++/40684, c++/40689, fortran/40440,
-- -- 	rtl-optimization/40667, target/40668
-- -- - avoid overlapping entries in .debug_ranges section (PR debug/40713)
-- -- 
-- -- * Wed Jul  8 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-12
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/35828, c++/37816, c++/37946, c++/40557, c++/40633, c++/40639,
-- -- 	debug/40666, target/38900
-- -- - use more compact DW_AT_member_location for constant offsets (PR debug/40659)
-- -- 
-- -- * Tue Jul  7 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-11
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/40274, c++/40342, c++/40566, c++/40595, c++/40619, c/39902,
-- -- 	fortran/40443, fortran/40551, fortran/40576, fortran/40594,
-- -- 	fortran/40638, libfortran/40576, libstdc++/40297, libstdc++/40600,
-- -- 	middle-end/40585, middle-end/40669, other/40024, target/40587,
-- -- 	tree-optimization/40493, tree-optimization/40542,
-- -- 	tree-optimization/40550, tree-optimization/40579,
-- -- 	tree-optimization/40582, tree-optimization/40640
-- -- - backports from trunk
-- --   - fix debuginfo in dynamically realigned functions (PR debug/40596)
-- --   - speed up polyhedron NF (PR middle-end/34163)
-- --   - epilogue unwinding fixes (PRs bootstrap/40347, debug/40462)
-- --   - fix debug info for inlines (PR debug/40573)
-- --   - optimize assuming allocatable arrays in the innermost
-- --     dimension are always stride 1 (PR fortran/32131)
-- -- 
-- -- * Tue Jun 23 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-10
-- -- - update from gcc-4_4-branch
-- --   - PRs fortran/39800, fortran/40402, libstdc++/40497, middle-end/40389,
-- -- 	middle-end/40404, middle-end/40446, middle-end/40460, objc/28050,
-- -- 	target/40470, tree-optimization/40492
-- -- - decrease memory consumption and speed up var-tracking pass (#503816)
-- -- - __builtin_object_size fix for C++ (#506952)
-- -- 
-- -- * Mon Jun 15 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-9
-- -- - update from gcc-4_4-branch
-- --   - PR fortran/40168
-- -- - fix up debug.exp testsuite (PR testsuite/40426)
-- -- - fix up a pasto in recent -D_FORTIFY_SOURCE changes (#506099)
-- -- 
-- -- * Fri Jun 12 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-8
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/40381, libfortran/40330
-- -- - add -mcrc32 support on ix86
-- -- - support -gdwarf-3 and default to it, emit DW_OP_call_frame_cfa
-- -- - fix up ix86 padding for branch mispredicts
-- -- - improve .debug_loc generation
-- -- 
-- -- * Tue Jun  9 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-7
-- -- - update from gcc-4_4-branch
-- --   - PRs ada/40166, bootstrap/40027, c++/38064, c++/39754, c++/40007,
-- -- 	c++/40139, c/40172, c++/40306, c++/40307, c++/40308, c++/40311,
-- -- 	c++/40370, c++/40372, c++/40373, debug/40109, fortran/22423,
-- -- 	fortran/38654, fortran/39893, fortran/40019, fortran/40195,
-- -- 	libfortran/25561, libfortran/37754, libfortran/38668,
-- -- 	libfortran/39665, libfortran/39667, libfortran/39702,
-- -- 	libfortran/39709, libfortran/39782, libfortran/40334,
-- -- 	libgfortran/39664, libgomp/40174, libstdc++/36211, libstdc++/40192,
-- -- 	libstdc++/40296, libstdc++/40299, middle-end/32950, middle-end/40147,
-- -- 	middle-end/40204, middle-end/40233, middle-end/40252,
-- -- 	middle-end/40291, middle-end/40328, middle-end/40340,
-- -- 	rtl-optimization/40105, target/40017, target/40153, target/40266,
-- -- 	testsuite/39907, tree-optimization/39999, tree-optimization/40087,
-- -- 	tree-optimization/40238, tree-optimization/40254
-- -- - support Atom for -march=native
-- -- - add -mmovbe support for Atom
-- -- - improve ix86 instruction length computation, remove some unneeded padding
-- -- - -D_FORTIFY_SOURCE improvements
-- -- - emit accurate epilogue unwinding information
-- -- - add unwind debug hook for gdb
-- -- 
-- -- * Thu May 14 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-5
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/17395, c/39983, fortran/38863, fortran/38956, fortran/39879,
-- -- 	fortran/40018, libstdc++/39546, libstdc++/40038, middle-end/39986,
-- -- 	middle-end/40021, middle-end/40023, middle-end/40043,
-- -- 	middle-end/40057, middle-end/40080, target/37179,
-- -- 	tree-optimization/40062, tree-optimization/40074
-- -- - fix Fortran FMT= character array arguments (#492209, PR fortran/39865)
-- -- - allow putting breakpoints on Fortran END{SUBROUTINE,FUNCTION}
-- --   (PR fortran/34153)
-- -- - incorporate changes suggested in gcc44 package review (#498911)
-- -- 
-- -- * Wed May  6 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-4
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/40013, libgcj/39899, libstdc++/39868, libstdc++/39880,
-- -- 	libstdc++/39881, libstdc++/39882, libstdc++/39909, middle-end/39937,
-- -- 	rtl-optimization/39914, target/39565, testsuite/39769,
-- -- 	testsuite/39776, testsuite/39790, testsuite/39807,
-- -- 	tree-optimization/39941
-- --   - fix phiprop tuplification (#496400, PR tree-optimization/40022)
-- -- - don't add artificial default case label if switch labels already
-- --   cover the whole range (PR middle-end/39666)
-- -- - fix DSE with block reads (PR middle-end/40035)
-- -- - fix debuginfo for C++ typedef struct {...} T (PR debug/35463)
-- -- - remove some unnecessary padding on x86_64/i386 added for >= 4 control
-- --   flow insns in a 16-byte block (PR target/39942)
-- -- - don't create invalid DWARF location lists containing DW_OP_reg*
-- --   followed by DW_OP_deref*, instead use DW_OP_breg* 0 (#481675)
-- -- - add libstdc++-docs subpackage, move html manual to it, add doxygen
-- --   generated html and man pages
-- -- 
-- -- * Mon Apr 27 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-3
-- -- - update from gcc-4_4-branch
-- --   - PR bootstrap/39739
-- --   - fix -Wunused-value (#497545, PR c/39889)
-- -- - backport further power7-meissner branch changes (#497816)
-- -- - fix reg-stack ICE on SPEC2k6 453.povray with -m32 -O3 -msse3
-- --   (PR target/39856)
-- -- - fix x86_64 ICE on passing structure with flexible array member
-- --   (PR target/39903)
-- -- 
-- -- * Fri Apr 24 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-2
-- -- - update from gcc-4_4-branch
-- --   - PR c++/38228
-- -- - fix folding of cond expr with comparison to MAX/MIN (PR middle-end/39867)
-- -- - fix up gcc-gnat install-info arguments (#452783)
-- -- 
-- -- * Thu Apr 23 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-1
-- -- - update from gcc-4_4-branch
-- --   - GCC 4.4.0 release
-- --   - PRs libstdc++/39802, c++/39639, c/39855, rtl-optimization/39762,
-- -- 	testsuite/39781, tree-optimization/39824
-- -- - fix up DSE (PR rtl-optimization/39794)
-- -- - debuginfo fixes for VLA and nested/contained functions (#459374)
-- -- - improve -ftree-switch-conversion optimization if the constant is the
-- --   same in all cases
-- -- 
-- -- * Mon Apr 20 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.35
-- -- - update from gcc-4_4-branch
-- --   - PRs middle-end/39804, target/39678, target/39767, tree-optimization/39675,
-- -- 	tree-optimization/39764
-- -- 
-- -- * Tue Apr 14 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.34
-- -- - update from gcc-4_4-branch
-- --   - GCC 4.4.0-rc1
-- --   - license changes to GPLv3+ with GCC Runtime Exception for most of the
-- --     lib* files
-- --   - PRs c++/28301, c++/39480, c++/39742, c++/39750, c/39613, c/39614, c/39673,
-- -- 	libobjc/36610, target/39740, testsuite/35621, tree-optimization/39713
-- -- - fix another -Wshadow C++ issue (PR c++/39763)
-- -- 
-- -- * Thu Apr  9 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.32
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/34691, c++/35146, c++/35240, c++/37806, c++/38030, c++/38850,
-- -- 	c++/39608, c++/39637, c++/4926, c/37772, fortran/38152,
-- -- 	fortran/39519, fortran/39594, libmudflap/38462, libstdc++/39310,
-- -- 	middle-end/39573, objc/18456, objc/27377, other/39591,
-- -- 	rtl-optimization/39588, rtl-optimization/39607, target/39501,
-- -- 	target/39592, target/39634, testsuite/39325, tree-optimization/35011,
-- -- 	tree-optimization/39595, tree-optimization/39648
-- --   - handle .cfi_undefined(%ip) in libgcc_s unwinder (#491542)
-- -- - fix debug info for C++ static data members (#410691)
-- -- - revert fwprop fix, it causes glibc.i586 miscompilation
-- -- 
-- -- * Mon Mar 30 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.31
-- -- - update from gcc-4_4-branch
-- --   - PR target/39545
-- --   - fix Fortran bind(c) function using RESULT() (#492657)
-- -- - fix bogus warnings on strcmp/strncmp macros (#492846)
-- -- 
-- -- * Sat Mar 28 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.30
-- -- - update from gcc-4_4-branch
-- --   - PRs c++/39380, c++/28274, c++/29727, c++/35652, c++/36799, c++/37647,
-- -- 	c++/38638, c++/39554, libfortran/39528, middle-end/39497,
-- -- 	rtl-optimization/39522, target/38034, target/39523,
-- -- 	tree-optimization/39529, tree-optimization/39548,
-- -- 	tree-optimization/39557
-- -- - emit debuginfo for block local externs in C (PR debug/39563)
-- -- - fix -maltivec conditional vector macro (PR target/39558)
-- -- - teach fwprop to handle asm (PR inline-asm/39543)
-- -- 
-- -- * Tue Mar 24 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.29
-- -- - update from trunk
-- --   - PRs c++/28879, c++/37729, c++/39526, debug/39524, tree-optimization/39516
-- -- 
-- -- * Thu Mar 19 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.28
-- -- - update from trunk
-- --   - PRs c++/39425, c++/39475, c/39495, debug/39485, middle-end/37805,
-- -- 	middle-end/38609, middle-end/39378, middle-end/39447,
-- -- 	middle-end/39500, target/35180, target/39063, target/39496
-- --   - fix RA bug with global reg variables (#490509)
-- -- - use DW_LANG_C99 for -std=c99 or -std=gnu99 compiled C code (PR debug/38757)
-- -- - emit DW_AT_explicit when needed (PR debug/37959)
-- -- - optimize memmove into memcpy in more cases when we can prove src and dest
-- --   don't overlap
-- -- 
-- -- * Tue Mar 17 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.27
-- -- - update from trunk
-- --   - PRs debug/37890, debug/39471, debug/39474, libstdc++/39405, target/34299,
-- -- 	target/39473, target/39476, target/39477, target/39482,
-- -- 	testsuite/37628, testsuite/37630, testsuite/37960, testsuite/38526,
-- -- 	tree-optimization/39455
-- -- 
-- -- * Sat Mar 14 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.26
-- -- - fix ppc64 regression caused by the power7 backport (#490149,
-- --   PR target/39457)
-- -- 
-- -- * Fri Mar 13 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.25
-- -- - update from trunk
-- --   - PRs debug/39086, debug/39432, libobjc/27466, middle-end/37850,
-- -- 	target/39137, target/39181, target/39431, target/39445, target/5362,
-- -- 	testsuite/39451, tree-optimization/39422
-- -- - fix ICE in gen_tagged_type_instantiation_die (#489308, PR debug/39412)
-- -- - fix memcmp builtin asm redirection (PR middle-end/39443)
-- -- - fix sparcv9 profiledbootstrap (PR bootstrap/39454)
-- -- 
-- -- * Thu Mar 12 2009 Dennis Gilmore <dennis@ausil.us>
-- -- - don't build with graphite support on sparc arches
-- --   - still missing some deps
-- -- 
-- -- * Tue Mar 10 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.24
-- -- - update from trunk
-- --   - PRs ada/39221, c++/39060, c++/39367, c++/39371, libfortran/39402,
-- -- 	middle-end/38028, target/39361, tree-optimization/39394
-- -- - use system cloog-ppl instead of building a private libcloog.so.0 (#489183)
-- -- - preliminary Power7 support (#463846)
-- -- 
-- -- * Sat Mar  7 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.23
-- -- - update from trunk
-- --   - PRs c++/13549, c++/29469, c++/29607, c++/33492, c++/37520, c++/38908,
-- -- 	c++/9634, debug/39372, middle-end/39360, rtl-optimization/39235,
-- -- 	testsuite/39357, tree-optimization/39349
-- --   - emit DW_TAG_imported* even in main or in lexical blocks that
-- --     contain no automatic variables (#488547, PR debug/39379)
-- --   - fix DW_AT_decl_line on DW_TAG_imported* (#488771, PR debug/39387)
-- --   - fix SCCVN with SSA names occurring in abnormal PHIs (#488061,
-- --     PR tree-optimization/39362)
-- -- 
-- -- * Wed Mar  4 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.22
-- -- - update from trunk
-- --   - PRs ada/39172, ada/39264, bootstrap/39257, c++/36411, c++/37789,
-- -- 	c++/38880, c++/39225, c++/39242, c/12245, classpath/38417,
-- -- 	classpath/38912, debug/39267, debug/39285, fortran/38914,
-- -- 	fortran/39292, fortran/39295, fortran/39309, fortran/39354,
-- -- 	libgcj/38861, middle-end/10109, middle-end/34443,
-- -- 	middle-end/39157, middle-end/39272, middle-end/39308,
-- -- 	middle-end/39335, middle-end/39345, rtl-optimization/39241,
-- -- 	target/33785, target/35965, target/39256, target/39261,
-- -- 	target/39327, testsuite/38164, tree-optimization/37709,
-- -- 	tree-optimization/39248, tree-optimization/39259,
-- -- 	tree-optimization/39260, tree-optimization/39318,
-- -- 	tree-optimization/39331, tree-optimizations/39259,
-- -- 	tree-optimization/39358
-- --   - fix ivopts (#486088, PR tree-optimization/39233)
-- --   - fix SRA (#487795, PR tree-optimization/39339)
-- --   - fix __builtin_object_size with unions (#487702,
-- --     PR tree-optimization/39343)
-- -- - fix ppc -m64 -O2 -mtune=cell and patterns (#485067, PR target/39226)
-- -- - -march=atom/-mtune=atom support from ix86/atom branch
-- -- 
-- -- * Thu Feb 19 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.21
-- -- - update from trunk
-- --   - PRs c++/39188, c++/39219, c/35447, c/38483, target/34587,
-- -- 	target/38891, target/39082, target/39179, target/39224,
-- -- 	target/39228, testsuite/38165, testsuite/38166,
-- -- 	tree-optimization/36922, tree-optimization/39074,
-- --   - another bogus aliasing warning fix (#485463, PR tree-optimization/39207)
-- -- - fix tail call optimization on ppc (#485067, PR target/39240)
-- -- 
-- -- * Tue Feb 17 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.20
-- -- - update from trunk
-- --   - PRs c/35446, middle-end/39214, tree-optimization/39202
-- --   - fix ICE in compute_attic (#485708, PR tree-optimization/39204)
-- --   - fix bogus aliasing warning (#485463, PR tree-optimization/39207)
-- -- - update for i386.rpm -> i586.rpm switch
-- -- 
-- -- * Mon Feb 16 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.19
-- -- - update from trunk
-- --   - PRs c++/39070, fortran/36528, fortran/36703, fortran/38259,
-- -- 	libstdc++/39168, target/37049, target/38056, target/39149,
-- -- 	target/39162, target/39196
-- --   - ix86 peephole fix (#485729, PR target/39152)
-- --   - uglify function parameter names in gthr*.h (#485619)
-- -- 
-- -- * Fri Feb 13 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.18
-- -- - update from trunk
-- --   - PRs c++/30111, c++/38950, c++/39153, c/35444, middle-end/39154,
-- -- 	target/38824, target/39152
-- -- - fix ICE on ppc32 with -fpic -fvisibility=hidden (#485232, PR target/39175)
-- -- 
-- -- * Wed Feb 11 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.17
-- -- - update from trunk
-- --   - fix ICE on xen (PR target/39139)
-- --   - PRs c++/34397, c++/35147, c++/36744, c++/37737, c++/38649, c++/39109,
-- -- 	c/35434, c/36432, c/39035, c/39084, middle-end/35202,
-- -- 	middle-end/38953, middle-end/38981, middle-end/39124,
-- -- 	middle-end/39127, target/39118, target/39119, testsuite/33300,
-- -- 	tree-optimization/39132
-- -- - force emitting .debug_info for empty CUs with -g3 (#479912)
-- -- 
-- -- * Fri Feb  6 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.16
-- -- - update from trunk
-- --   - don't emit thunks for versioned functions (PR c++/39106)
-- --   - fix -fstrict-aliasing miscompilation (PR tree-optimization/39100)
-- -- 
-- -- * Wed Feb  4 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.15
-- -- - update from trunk
-- --   - C++ mangling fix (PR c++/39095)
-- --   - only complain about calling main in C++ if -pedantic
-- -- - add raw string support
-- -- 
-- -- * Tue Feb  3 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.14
-- -- - update from trunk
-- -- - when compiling with -march=i386, don't use __sync_* builtins in
-- --   ext/atomicity.h
-- -- 
-- -- * Wed Jan 28 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.13
-- -- - fix graphite make check
-- -- 
-- -- * Tue Jan 27 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.12
-- -- - update from trunk
-- -- - add graphite support
-- -- - change gcc default ISA and tuning:
-- --   i386 and x86_64 -m32:
-- --   -march=i586 -mtune=generic from -march=i386 -mtune=generic
-- --   x86_64 -m64 remains at:
-- --   -march=x86-64 -mtune=generic
-- --   s390 and s390x -m31:
-- --   -march=z9-109 -mtune=z10 from -march=g5 -mtune=z9-109
-- --   s390x -m64:
-- --   -march=z9-109 -mtune=z10 from -march=z900 -mtune=z9-109
-- -- 
-- -- * Wed Jan 21 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.9
-- -- - rebuilt without ppc64 ada bootstrap hacks
-- -- 
-- -- * Tue Jan 20 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.8
-- -- - attempt to enable Ada support on ppc64
-- -- 
-- -- * Fri Jan 16 2009 Jakub Jelinek <jakub@redhat.com> 4.4.0-0.3
-- -- - initial 4.4 package, using newly created redhat/gcc-4_4-branch
-- 
-- * Sat May  9 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-2m)
-- - update to 4.4-20090505
-- 
-- * Fri May  1 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-1m)
-- - update to 4.4-20090428
-- 
-- * Wed Apr 15 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.1.1m)
-- - update to 4.4-20090414
-- 
-- * Sun Apr 12 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090407.1m)
-- - update to 4.4-20090407
-- 
-- * Sun Mar 29 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090327.1m)
-- - update to 4.4-20090327
-- 
-- * Sat Mar 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090320.1m)
-- - update to 4.4-20090320
-- 
-- * Sat Mar 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090313.1m)
-- - update to 4.4-20090313
-- 
-- * Sun Mar  8 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090306.1m)
-- - update to 4.4-20090306
-- 
-- * Sat Feb 28 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090227.1m)
-- - update to 4.4-20090227
-- 
-- * Sun Feb 22 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090220.1m)
-- - import gcc-test/gcc44 changes (4.4.0-0.18m)
-- 
-- * Sat Feb 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090213.1m)
-- - update to 4.4-20090213
-- -- removed addr2name.awk
-- 
-- * Sat Feb  7 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090206.1m)
-- - update to 4.4-20090206
-- 
-- * Sun Feb  1 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090130.1m)
-- - import gcc-test/gcc44 changes (4.4.0-0.15m)
-- 
-- * Thu Jan 22 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090116.1m)
-- - import gcc-test/gcc44 changes (4.4.0-0.13m)
-- 
-- * Thu Jan 22 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (4.4.0-0.0.20090109.1m)
-- - rebase from gcc-test/gcc44 (4.4.0-0.12m)
-- - build with --disable-werror
-- -- 
-- -- * Sat Jan 10 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.12m)
-- -- - update to 20090109
-- -- 
-- -- * Sun Jan  4 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.11m)
-- -- - update to 20090102
-- -- 
-- -- * Mon Dec 29 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.9m)
-- -- - update to 20081226
-- -- 
-- -- * Sat Dec 20 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.9m)
-- -- - update to 20081219
-- -- - delete gcc44-workarounds.patch
-- -- - revise Provideds: and Requires:
-- -- 
-- -- * Fri Dec  5 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.8m)
-- -- - update to 20081205
-- -- 
-- -- * Sat Nov 29 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.7m)
-- -- - update to 20081128
-- -- 
-- -- * Sun Nov 23 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.6m)
-- -- - update to 20081121
-- -- - revise %%files
-- -- - add gcc44-workarounds.patch 
-- -- -- fix compilation error on bootstrapping
-- -- -- rename libgfortran's soname to avoid ABI breakage
-- -- 
-- -- * Sun Nov 16 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.5m)
-- -- - update to 20081114
-- -- 
-- -- * Fri Nov  7 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.4m)
-- -- - update to 20081107
-- -- - fix up java_bootstrap build
-- -- 
-- -- * Sat Oct 25 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.3m)
-- -- - update to 20081031
-- -- -- switch %%build_test to 1 for a while
-- -- 
-- -- * Sun Oct 12 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.2m)
-- -- - revise spec
-- -- -- separate fastjar again
-- -- -- revise Provides: and Obsoletes:
-- -- 
-- -- * Sat Oct 13 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- -- - (4.4.0-0.1m)
-- -- - for upcoming GCC 4.4

* Tue Sep 29 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.4-2m)
- update gcc-4.3-20090925
--  PR target/40473, c/39779, c/41049, middle-end/41009
--  middle-end/37850, testsuite/41288, libffi/40242, libffi/41443

* Sat Aug 29 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.4-1m)
- update gcc-4.3-20090829(gcc-4.3.4)
- PR c/39902, c/41046, debug/39706
--   fortran/40847, fortran/40851, fortran/41102
--   middle-end/41094, rtl-optimization/41033
--   target/40577, target/40718, target/40906
--   target/41019, PR target/8603

* Fri Jul 31 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-13m)
- update gcc-4.3-20090731 (r150284)
-- PR target/40832, bootstrap/38903

* Tue Jul 21 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-12m)
- update gcc-4.3-20090721 (r149851)
-- PR c++/37877, 36089, 40566
--   target/39943, rtl-optimization/40710
--   rtl-optimization/39110, 37889, 38921
--   middle-end/40291, 38934, 40328, 40585
--   tree-optimization/40669, 40542, 40579
--   fortran/40638

* Mon Jul 13 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-11m)
- update gcc-4.3-20090629 (r149041)
-- bootstrap/40061, c++/36607,39371,40373, c/32041,39855
-- debug/40061, 40109, fortran/39879, libgcj/38396
-- middle-end/38751, 39986, 40057, 40147, 40204, 40389, 40404, 40460
-- objc/28050, other/40024,rtl-optimization/40105
-- target/35318, 37179, 38222, 39013, 39240, 39501, 39942, 40153, 40470
-- tree-optimization/32044, 36891, 39455, 40062, 40087, 40550

* Mon Jul 13 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-10m)
- add Requires(post,preun,postun)
- remove unnecessary fastjar stuff, breaks build (bash40 issue)

* Sun Jul  5 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.3-9m)
- "install-info --delete" should be in %%preun

* Sun Jul  5 2009 Nishio Futoshi <futoshi@momonga-linux.org>
- (4.3.3-8m)
- add Requires(post): info to libgomp

* Sat Jun 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-7m)
- rebuild against xulrunner-1.9.1

* Tue May  5 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-6m)
- BuildRequires: /usr/share/java/eclipse-ecj.jar if %%{build_java}

* Sat May  2 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-5m)
- update to gcc-4.3-20090501 (r147026)
-- PR fortran/39791
-- PR target/39496
-- PR target/39740
-- PR target/39634
-- PR testsuite/39769
-- PR c++/38228
-- PR c++/39639
-- PR c++/39480
-- PR c++/28301
-- PR c++/39637
-- PR c++/35146
-- PR bootstrap/39739

* Sat Apr 11 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-4m)
- update to gcc-4.3-20090406 (r145576)
-- PR objc/27377
-- PR rtl-optimization/39588
-- PR target/39175
-- PR target/39482
-- PR libfortran/39528
-- PR fortran/39519
-- PR objc/18456
-- PR objc/27377
-- PR c++/38030, 38850, 39070

* Fri Mar 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.3-3m)
- update to gcc-4.3-20090319 (r144971)
-- PR c++/9634,29469,29607,38950,39070,39225,39425
-- PR c/35444,35446
-- PR fortran/38852,39006,39292,39295
-- PR inline-asm/39058
-- PR libstdc++/39405
-- PR middle-end/36578,37861
-- PR rtl-optimization/39241
-- PR target/38056,39228,39327,39477
-- PR testsuite/39451
- License: GPLv3+ and "GPLv2+ with exceptions"

* Wed Feb 25 2009 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.3.3-2m)
- add BuildRequires: /lib/libc.so.6 /usr/lib/libc.so /lib64/libc.so.6 /usr/lib64/libc.so
  for fix multilib_64_archs build

* Fri Feb 13 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.3-1m)
- update 4.3.3-20090212

* Wed Jan 21 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.3.2-9m)
- set --with-pkgversion="Momonga Linux 6"

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.2-8m)
- rebuild against rpm-4.6

* Sat Jan 17 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (4.3.2-7m)
- %%global _default_patch_fuzz 2

* Thu Dec 25 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-6m)
- update 20081223
- fix many PRs
-- bootstrap:  33100, 38383
-- c++      :  37142, 35405, 37563, 37582
-- libstdc++:  37144, 38080
-- fortran:    38602, 38487, 38113, 35983, 35937, 34820, 34143, 32795
--             38033, 37926, 37792, 35681, 38171, 37735, 36526 
-- libfortran: 38135
-- target:     38402, 38254, 38287, 38054, 37640, 38062
-- middle-end: 38565
-- testsuite:  35677, 28870
-- tree-optimization:38478, 37868
-- other:      38214

* Mon Nov 17 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-5m)
- update 20081116

* Wed Oct 15 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-4m)
- add gcc43-pr29609-2.patch, gcc43-pr29609-3.patch

* Thu Oct  9 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-3m)
- update 20081008

* Thu Sep 18 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-2m)
- import Fedora patch.(gcc-4.3.2-3)
- BPR mpfr-3.3.2
- merge gcc-4.3.2-rh-r140410.patch

* Fri Sep  5 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.2-1m)
- import gcc-test branch changes
- import Fedora patch.(gcc-4.3.2-1)
- add 4.3_stable patch(r139965)
-- PR c/37261, c++/37348, target/36332, target/37168
--    fortran/37193, fortran/36371, middle-end/37248
--    middle-end/36449

* Wed Jul 30 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.1-7m)
- import Fedora patch.(gcc-4.3.1-5)
- add PR c++/36852 patch

* Sun Jul 27 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.1-6m)
- update gcc-4.3-20080727(r138187)
- add bootstrap_gcj flag

* Wed Jul  9 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (4.3.1-5m)
- merge fedora gcc-4.3-4

* Sun Jul  6 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-4m)
- update gcc-4.3-20080704 upstream patch
- use eclipse-ecj-3.3.2.jar

* Fri Jun 27 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-3m)
- merge from fedora gcc-4.3.1-3
- update gcc-4.3-20080626 upstream patch

* Tue Jun 17 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-2m)
- merge from fedora gcc-4.3.1-2
- update gcc-4.3-20080616 upstream patch

* Tue Jun 10 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.1-1m)
- merge from fedora gcc-4.3.1

* Thu May 29 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-16m)
- merge from gcc-4.3-branch(20080529)

* Mon May 19 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-15m)
- merge from gcc-4.3-branch(20080519)

* Tue Apr 29 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.3.0-14m)
- rebuild against firefox-3
- add BuildRequires: xulrunner-devel

* Tue Apr 29 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-13m)
- import fedora patches
-  * Mon Apr 28 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-8
- - update from gcc-4_3-branch
- - decrease compile time stack usage during GC (#443739, PR debug/36060)
- - fix -mregparm=X with K&R function decls (#443583, PR target/36015)
- - fix tail called sqrt and math builtins (#435297,
-   PR rtl-optimization/36017)
- - PRs c++/33486, c++/35316, c++/35325, c++/35678, c++/35747, c++/35758,
-   c++/35773, c/35436, c/35744, fortran/35932, fortran/35944,
-   fortran/35946, fortran/35947, fortran/35959, fortran/35994,
-   libgcj/35950, libstdc++/35597, libstdc++/35887, libstdc++/35954,
-   middle-end/36021, target/35944, testsuite/36056,
-   tree-optimization/35982, tree-optimization/36008,
-   tree-optimization/36034
- - fix C++ const references to bitfields (PR c++/35909)
- - fix C++ ++var = val error recovery (PR c++/35987)
- - fix C++ reference binding to function through using-decl (PR c++/35650)

* Thu Apr 17 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.3.0-12m)
- delete BuildRequires: firefox-devel

* Thu Apr 17 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-11m)
- fortran Req mpfr-devel
- import fedora patches
- * Wed Apr 16 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-7
- - update from gcc-4_3-branch
- - PRs c++/35708, c++/35734, libstdc++/35816, middle-end/35519,
-       rtl-optimization/34916, target/35364, target/35695,
-       tree-optimization/35821, tree-optimization/35833
- - fix libgfortran buffer overflows
- - fix restoring of Altivec registers when alloca is used (PR target/35907)
- - misc fixes (PRs tree-optimization/35899, target/35662, c/35739)

* Sat Apr  5 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.3.0-10m)
- import fedora patches
- * Fri Apr  4 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-6
- - update from gcc-4_3-branch
-   - PRs ada/33857, c++/35245, c++/35741, c/35738, fortran/35698,
- 	fortran/35699, fortran/35702, fortran/35724, fortran/35740,
- 	fortran/35786, libfortran/35699, libstdc++/35725, middle-end/35429,
- 	middle-end/35705, middle-end/35818, target/31110, target/31232,
- 	target/35657, tree-opt/35431
- - fix OpenMP ICE on invalid extern/static VLA (PR c/35751)
- - fix PCH failure if a precompiled header is included more than
-   once (#251682, PR pch/13675)

* Wed Apr  2 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.3.0-9m)
- copy from branches/TSUPPA4RI/gcc r23138
--
-- * Mon Mar 31 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-8m)
-- - add BuildRequires: fastjar
-- 
-- * Sun Mar 30 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-7m)
-- - fix x86_64 support, again
-- 
-- * Sun Mar 30 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-6m)
-- - fix x86_64 support
-- 
-- * Sat Mar 29 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-5m)
-- - fix libgcj_bc.so issue
-- - cleanup spec
-- 
-- * Fri Mar 28 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-4m)
-- - update to 4.3.0 
-- -- merge from T4R/gcc-test/gcc43 r23069
-- -- disable alternatives support
-- -- remove bin_suffix and pkg_suffix
-- -- fix some %%{bin_suffix} issues
-- - revise spec
-- -- now *info are compressed by bzip2
-- 
-- * Fri Mar 28 2008 Yohsuke Ooi <meke@momonga-linux.org>
-- - (4.3.0-3m)
-- - import fedora patch
-- - * Thu Mar 27 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-5
-- - - fix libgomp when sync builtins aren't available
-- - - on i386 build libgomp and __cxa_guard_* as i486+,
-- -   NPTL doesn't support pre-i486 anyway and atomic builtins give
-- -   significant speedups
-- - 
-- - * Wed Mar 26 2008 Jakub Jelinek <jakub@redhat.com> 4.3.0-4
-- - - update from gcc-4_3-branch
-- -   - PRs c++/35332, c++/35548, debug/31510, fortran/33295, fortran/34813,
-- - 	libfortran/35617, libfortran/35627, libgomp/35625, libstdc++/35256,
-- - 	libstdc++/35637, middle-end/35593, middle-end/35609,
-- - 	middle-end/35611, middle-end/35616, target/35504, testsuite/34168,
-- - 	testsuite/35621
-- - - backport libgomp speedups from gomp-3_0-branch (#437268)
-- - - fix diagnostics with compound literals (PR c/35440)
-- - - fix C++ handling of late template attributes (PR c++/35546)
-- - - Prereq install-info in libgomp (#437523)
-- 
-- * Fri Mar 21 2008 Yohsuke Ooi <meke@momonga-linux.org>
-- - (4.3.0-2m)
-- - import fedora patch
-- 
-- * Fri Mar  7 2008 Yohsuke Ooi <meke@momonga-linux.org>
-- - (4.3.0-1m)
-- - update to 4.3.0-release
-- 
-- * Sat Mar  1 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.25m)
-- - update to snapshots/4.3-20080228
-- 
-- * Fri Feb 22 2008 Yohsuke Ooi <meke@momonga-linux.org>
-- - (4.3.0-0.24m)
-- - update to snapshots/4.3-20080221
-- 
-- * Tue Feb 19 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.23m)
-- - add update-ccache.sh in %%post and %%postun
-- 
-- * Fri Feb 15 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.22m)
-- - update to snapshots/4.3-20080215
-- 
-- * Sat Feb  9 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.21m)
-- - import ia64 support patches from fc-devel
-- 
-- * Sat Feb  9 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.20m)
-- - update to snapshots/4.3-20080208
-- 
-- * Fri Jan 25 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.18m)
-- - update to snapshots/4.3-20080125
-- - update gcc43-rename-info.patch 
-- - delete gcc43-fix-protoize.patch
-- 
-- * Thu Jan 17 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.17m)
-- - updated to snapshots/4.3-20080118
-- - added libffi sub-package
-- - deleted gcc43-adhoc.patch
-- - revised libgcc sub-package
-- 
-- * Thu Jan 10 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.16m)
-- - updated to snapshots/4.3-20080111
-- 
-- * Fri Jan  4 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.15m)
-- - updated to snapshots/4.3-20080104
-- - revised %%files section
-- - deleted OPT_FLAGS hack
-- 
-- * Fri Dec 21 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.14m)
-- - updated to snapshots/4.3-20071221
-- 
-- * Sat Dec 15 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.13m)
-- - updated to snapshots/4.3-20071214
-- - deleted REMOVE.PLEASE
-- - imported two patches from fc-devel (gcc-4_3_0-0_3)
-- -- gcc43-build-id.patch
-- -- gcc43-c++-builtin-redecl.patch
-- 
-- * Sat Dec  8 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.12m)
-- - updated to snapshots/4.3-20071207
-- 
-- * Thu Nov 29 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.11m)
-- - updated to snapshots/4.3-20071130
-- - fixed alternatives support
-- - added all *.h in %%{_prefix}/lib/gcc/%%{gcc_target_platform}/
-- - added gc-analyze and gnative2ascii to libgcj
-- - added "Require:" for libgomp, libobc and libmudflap
-- 
-- * Sat Nov 24 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.10m)
-- - updated to snapshots/4.3-20071123
-- - added --with-pkgversion
-- - revised alternatives support again
-- 
-- * Wed Nov 21 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.9m)
-- - revised alternatives support again
-- 
-- * Thu Nov 15 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.8m)
-- - updated to snapshots/4.3-20071116
-- - added header files generated by fixincludes
-- - fixed alternatives
-- 
-- * Sat Nov 10 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.7m)
-- - updated to snapshots/4.3-20071109
-- 
-- * Sat Nov  3 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.6m)
-- - updated to snapshots/4.3-20071102
-- 
-- * Wed Oct 24 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.5m)
-- - updated to snapshots/4.3-20071026
-- - changed BOOT_CFLAGS to fix bootstrap failure
-- - added gcc43-fix-protoize.patch
-- - updated gcc43-rename-info.patch
-- 
-- * Sat Oct 20 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.4m)
-- - updated to snapshots/4.3-20071019
-- 
-- * Thu Oct 18 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.3m)
-- - added gcc43-adhoc.patch
-- - added REMOVE.PLEASE so that gcj won't be built with installed ecj1
-- 
-- * Wed Oct 17 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.2m)
-- - fixed gcj
-- -- updated gcc43-fix-gcj.patch
-- -- added %%{_prefix}/%%{_lib}/gcj-%%{version}/libgcj_bc.so.1 for ecj1
-- 
-- * Sat Oct 13 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
-- - (4.3.0-0.1m)
-- - inital import for GCC's 4.3 branch

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-25m)
- %%NoSource -> NoSource

* Thu Jan  3 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-24m)
- import Fedora Patch(gcc-4.1.2-37)

* Mon Dec  5 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-23m)
- import Fedora Patch(gcc-4.1.2-35)
-* Sun Dec  2 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-35
- - two ctor preevaluation fixes (Olivier Hainque,
-   Eric Botcazou, #407281)
- - slightly weaken diagnostics for declared, but undefined static data
-   members in anon ns classes (#402521, PR c++/34238)
- - consider static data members and static member functions in anon ns
-   classes to be external for C++ linkage type handling (PR c++/34213)
- - handle OBJ_TYPE_REF in C++ diagnostics (PR c++/34275)

* Mon Dec  3 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-22m)
- fix nobuild kernel...

* Thu Nov 29 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-21m)
- import Fedora(gcc-4.1.2-34)
-* Sat Nov 24 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-34
-- update from gcc-4_1-branch (-r128736:130387)
-  - PRs middle-end/34030, rtl-optimization/28062, rtl-optimization/33822
-  - fix if-conversion to avoid introducing races into threaded code
-    (Ian Lance Taylor, #391731)
-- some C++ visibility fixes (Jason Merrill, PRs c++/32470, c++/33094,
-  c++/29365)
-- arm Java support (Andrew Haley, #246800)
-- add possibility to bootstrap gcj on architectures where libgcj
-  isn't already available or is too old - build on some already
-  supported arch the rpm with --with java_tar and the created
-  tarball bring to the new arch and build --with java_bootstrap
-- backport a bunch of bugfixes from GCC trunk
-  - PRs c++/29225, c++/30293, c++/30294, c++/30988, c++/32241,
-        c++/32384, c++/33501, c++/33516, c++/33616, c++/33836,
-        c++/33842, c++/33844, c++/33962, c++/34089, c++/34094,
-        c/34146, debug/33537, middle-end/23848, middle-end/34070,
-        testsuite/33978, tree-optimization/33723
-- fix abs optimization (Richard Guenther, #394271, PR middle-end/34130)
-- fortran lbound/ubound fix (Paul Thomas, #391151, PR fortran/29712)
-- generate proper fortran debuginfo for assumed-size, assumed-shape
-  and deferred arrays (#364001)

* Mon Nov  5 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-20m)
- import Fedora(gcc-4.1.2-33)
-- * Sun Oct 21 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-33
-- - rebuild to fix multilib conflict between i386 and x86_64 libgcj,
--   set java man page timestamp from the timestamp of *.texinfo rather
--   than current date to avoid this problem in the future (#341221)
-- - fix ppc64 unwinding of cr2 register if vdso=0
-- 
-- * Tue Oct 16 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-32
-- - only allow __label__ at the start of a block (PR c++/32121)
-- - disable -fipa-type-escape by default (PR tree-optimization/33136)
-- - VLA handling fix (PR c/33238, PR c/27301)
-- - disable TER of pure and const function calls except for __builtin_expect
--   (PR tree-optimization/33619)
-- - handle classes with characters other than [a-zA-Z0-9_$] in
--   their names (Andrew Haley, #297961, PR java/33639)
-- - fix parsing of C++ function-like cast in template argument where cast's
--   argument uses greater-than operator (PR c++/33744)
-- - ignore always_inline attribute on redefined extern inline
--   functions (Jan Hubicka, #329671, PR tree-optimization/33763)
-- - add support for Fortran int conversion intrinsics (Francois-Xavier
--   Coudert, #317051)
-- - link libgcj-tools.so* against libgcj.so* (#330771)

* Wed Oct  3 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-19m)
- sync Fedora(gcc-4.1.2-31)

* Tue Sep 18 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-17m)
- sync Fedora(gcc-4.1.2-25)

* Fri Sep  7 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-16m)
- sync Fedora(gcc-4.1.2-23)

* Thu Aug 30 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-16m)
- BuildRequires gmp-devel >= 4.2.1-2m
-- mpfr-2.3.0
- sync Fedora devel(4.1.2-19)
-- update from gcc-4_1-branch (-r127528:127672)
-  - PR c++/32112
-- fix ppc32 libgcc.a(tramp.o), so that binaries using trampolines
-  aren't forced to use bss PLT
-- fix a fortran charlen sharing bug (#253102)
-- fix ICE with X|~X or X^~X with vectors (PR middle-end/32912)
-- nuke bits/stdc++.gch directories from libstdc++-devel (#253304)


* Mon Aug 21 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-15m)
- sync Fedora devel
-* Thu Aug 16 2007 Jakub Jelinek <jakub redhat com> 4.1.2-18
-- update from gcc-4_1-branch (-r126830:127528)
-  - PR c++/17763
-- fix --build-id patch on ia64 (#251936)
-- fix fortran Tx format handling (Jerry DeLisle, #252152,
-  PR libgfortran/32678)
-- add support for Sun UltraSPARC T1 chips - -mcpu=niagara (David S. Miller)
-- don't NRV optimize fields inside anonymous unions (PR c++/32992)
-- fortran debuginfo improvements for constant bound arrays (#248541,
-  PR fortran/22244)
-- BuildRequire mpfr-devel

* Tue Jul 24 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-14m)
- sync Fedora devel(4.1.2-16)

* Sun Jul  8 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-13m)
- unused gcc-4.1.2-20070704.tar.bz2
- cleanup spec

* Sat Jul  7 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.1.2-12m)
- sync fedora 4.1.2-15
- +* Wed Jul  4 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-15
- - update from gcc-4_1-branch (-r126008:126302)
-  - PRs boehm-gc/21940, boehm-gc/21942, target/28307, target/32506,
-	tree-optimization/31966, tree-optimization/32533
- - merge in redhat/gcc-4_1-jdwp-merge-branch
-   - JDWP support (Keith Seitz)
- - fix OpenMP handling of Fortran POINTER non-array vars (PR fortran/32550)

* Sat Jun 30 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-11m)
- sync fedora 4.1.2-14
- * Tue Jun 26 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-14
- - update from gcc-4_1-branch (-r125727:126008)
-   - PRs inline-asm/32109, rtl-optimization/28011, target/32389
- - gomp update from gcc-4_2-branch (-r125917:125918)
-   - PR middle-end/32362
- - on ppc{,64} when tuning for power6{,x}, try to put the base
-   register as first operand in instructions to improve
-   performance (Peter Bergner, #225425, PR middle-end/28690)
- - on ppc64 emit nop after a call and disallow sibling calls
-   if the target function is not defined in the same object file
-   (David Edelsohn, #245424)
- - gomp parallel sections fix and fix for checking whether combined
-   parallel can be used (PR libgomp/32468)

* Sat Jun 16 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-10m)
- sync fedora 4.1.2-13

* Sat May 19 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-9m)
- import any patch from FC

* Wed May  9 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-8m)
- update FC-gcc-4.1.2-20070504
- remove Requires: ecj-compat

* Sat Apr 21 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-7m)
- sync fc-devel(4.1.2-10)
- BuildRequire: ecj-compat

* Sun Apr 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-6m)
- /libexec/gcc/%%{gcc_target_platform}/%%{gcc_version}/ecj1

* Sun Apr 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-5m)
- The link of the following commands is made 
-- sparc-%{_vendor}-%{_target_os}-c++
-- ppc-%{_vendor}-%{_target_os}-c++

* Sun Apr 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-4m)
- "-DPIC" remove GCJFLAGS.

* Fri Apr 13 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.2-3m)
- sync with fc-devel (4.1.2-8)
- Source100: eclipse-ecj.jar was added in the local
-- import from	eclipse-ecj-3.2.2-7.fc7.i386.rpm

* Tue Feb 27 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.2-2m)
- merged the changes in TSUPPA4RI-branch (-r14233:14281)
-- replace patch1000
-- revise spec
--- modifiy %dir tags

* Thu Feb 15 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.2-1m)
- update 4.1.2
- sync with fc-devel (4.1.2-1)
--* Wed Feb 14 2007 Jakub Jelinek <jakub@redhat.com> 4.1.2-1
--- update from gcc-4_1-branch (-r121738:121962)
--  - GCC 4.1.2 release
--  - PRs fortran/24783, testsuite/30649, middle-end/30313
--- fix ICE in dwarf2out with limbo die nodes in namespace context
--  (Alexandre Oliva, #227376)
--- fix a SRA bug with bitfields (Alexandre Oliva, #223576)

* Mon Feb 12 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-40m)
- sync with fc-devel (4.1.1-57)
--* Sun Feb 11 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-57
--- package up ammintrin.h on i386/x86_64
--- fix AMDfam10 testcases (H.J. Lu)
--- fix f951 assert accessing memory after free (H.J. Lu, PR fortran/27351)

* Sun Feb 11 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-39m)
- sync with fc-devel (4.1.1-56)
--* Sat Feb 10 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-56
--- update from gcc-4_1-branch (-r121479:121738)
--  - PRs c++/29487, target/29487, target/30370
--- merge gomp fixes from gcc-4_2-branch (-r121689:121690)
--  PR c++/30703
--- add AMDfam10 support (Harsha Jagasia, #222897)
--- set build_ada to 1 on alpha (#224247)
--- regenerate libjava.util.TimeZone data from tzdata2007a (#227888)

* Sat Feb  3 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-38m)
- sync with fc-devel (4.1.1-55)
--* Fri Feb  2 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-55
--- update from gcc-4_1-branch (-r121069:121479)
--  - PRs c++/28988, fortran/30278, libstdc++/30586, middle-end/29683,
--	objc/27438
--- add -march=core2 and -mtune=core2 support (Vlad Makarov)
--- fix sprintf builtin (PR middle-end/30473)
--- fix ICE on invalid __thread register on fields (PR c++/30536)
--- ignore install-info errors in scriptlets (#223687)
--- rename MNI and mni to SSSE3 and ssse3, keep -m{,no-}mni option and
--  __MNI__ macro for compatibility

* Wed Jan 24 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-37m)
- sync with fc-devel (4.1.1-54)
--* Tue Jan 23 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-54
--- update from gcc-4_1-branch (-r120507:121069)
--  - PRs c++/28999, libgfortran/30435, objc/30479, rtl-optimization/29329,
--	target/30173, testsuite/12325
--- OpenMP fixes (PRs middle-end/27416, middle-end/30421, middle-end/30494)

* Wed Jan 10 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-36m)
- sync with fc-devel (4.1.1-53)
--* Tue Jan  9 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-53
--- fix libgomp testsuite driver (Ulrich Weigand)
--- combiner fixes (Richard Sandiford, PR rtl-optimization/25514,
--  PR rtl-optimization/27736)

* Sat Jan  6 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-35m)
- sync with fc-devel (4.1.1-52)
--* Fri Jan  5 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-52
--- update from gcc-4_1-branch (-r120325:120507)
--  - PRs c++/30382, middle-end/27826, middle-end/28116,
--	tree-optimization/30212
--
--* Thu Jan  4 2007 David Woodhouse <dwmw2@redhat.com> 4.1.1-51
--- bootstrap Ada on ppc32 (David Woodhouse)
--- fix complex division with -std=c99 or -std=gnu99 (PR c/30360)
--
--* Wed Jan  3 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-50
--- backwards compatibility with old layout of struct _Unwind_Context
--  (#220627)
--- fix preprocessor defines in assembly preprocessed with -std=...
--  (Steven Bosscher, PR c/25993)
--- fix PCH creation with templates (Jason Merrill, PR c++/28217)
--- fix dwarf2out ICE (Alexandre Oliva, #217529, PR debug/30189)

* Wed Jan  3 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-34m)
- merge from trunk (r13401)
- sync with fc-devel (4.1.1-49)
--* Tue Jan  2 2007 Jakub Jelinek <jakub@redhat.com> 4.1.1-49
--- update from gcc-4_1-branch (-r120062:120325)
--  - PRs debug/26964, fortran/30200, libfortran/30145
--- fix endless recursion in negate_expr/fold_unary (PR middle-end/30286)
--- fix cpp problem on empty source files (Tom Tromey, PR preprocessor/30001)
--- improve constructor disambiguation (Mark Mitchell, PR c++/28261,
--  PR c++/29535)
--- fix handling of non-NULL attribute on nested functions (Andrew Pinski,
--  PR tree-opt/30045)
--- fix ICE with friend templatized static member function (PR c++/29054)

- * Mon Jan  1 2007 Dai OKUYAMA <dai@ouchi.nahi.to>
- (4.1.1-33m)
- ppc/sparc fix

* Thu Dec 21 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-32m)
- sync with fc-devel (4.1.1-48)
-* Wed Dec 20 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-48
-- update from gcc-4_1-branch (-r119833:120062)
-  - PRs libstdc++/11953, target/24036
-- fix ia64 EH region boundaries where last br.call in the region
-  is not at the end of a bundle (#219596, PR target/30230)
-- fix DI resp. TImode __sync_*_compare_and_swap on i?86 resp. x86_64
-  (Kazu Hirata, #220258, PR target/27266)
-- fix asm vs. nested functions or OpenMP (#220250, PRs middle-end/30262,
-  middle-end/30263)
-- fix handling of complex shared OpenMP vars (Andrew Pinski,
-  PR middle-end/30143)

* Fri Dec 15 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-31m)
- sync with fc-devel (4.1.1-47)
-* Thu Dec 14 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-47
-- fix ia64 prologue generation (Andreas Schwab, #219594, PR target/29166)
-- fix ppc64 divdi3 (PR target/30185)
-* Wed Dec 13 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-46
-- update from gcc-4_1-branch (-r119654:119833)
-  - PRs c++/27316, c++/28740, c++/29732, fortran/29820, fortran/29821,
-	fortran/29912, fortran/29916, fortran/30003, libstdc++/26497,
-	libstdc++/28125, libstdc++/28265, target/30039
-- fix loop unswitching (Zdenek Dvorak, #219138, PR rtl-optimization/30113)

* Sat Dec  9 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-30m)
- sync with fc-devel (4.1.1-45)
- fix patch1016
-* Fri Dec  8 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-45
-- update from gcc-4_1-branch (-r119343:119654)
-- - PRs c++/14329, c++/28284, c++/29632, c++/29728, c++/29729, c++/29730,
--	c++/29733, c++/30022, libfortran/29810
-- add protoize.1 and unprotoize.1 man pages (#188914)
-- fix RTL sharing problem in combine (#218603, PR rtl-optimization/27761)
-- additions to libgcj-src (Ben Konrath, PR libgcj/30110)

* Fri Dec  1 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-29m)
- sync with fc-devel (4.1.1-44)
-* Fri Dec  1 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-44
-- fix OpenMP loops with 0 iterations (PR libgomp/29947)
-* Thu Nov 30 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-43
-- update from gcc-4_1-branch (-r119167:119343)
-  - PRs c++/29022, fortran/29391, fortran/29489, fortran/29982,
-	libgfortran/29936, target/29319, tree-opt/29964
-- fix -fopenmp ICEs on omp constructs where the body never returns
-  (PR middle-end/29965)

* Sat Nov 25 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-28m)
- sync with fc-devel (4.1.1-42)
-* Fri Nov 24 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-42
-- update from gcc-4_1-branch (-r119021:119167)
-  - fix s390{,x} __sync_* builtins
-- fix ppc64 libffi unwind info
-* Thu Nov 23 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-41
-- fix ICE with -fopenmp -fexceptions on ia64 (#216988, PR c/29955)
-- fix parsing of C++ if/switch/etc. conditions (PR c++/29886)

* Thu Nov 23 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-27m)
- add BuildRequires for testsuite
- sync with fc-devel (4.1.1-40)
-* Wed Nov 22 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-40
-- disallow multiple vector_size attributes (PR c/29736)
-- don't ICE on main returning int with vector_size attribute (PR c++/29735)
-- hide symbols that shouldn't be exported from libgcj.so (GC_*, ffi_*,
-  lt_* etc., #216120)

* Wed Nov 22 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-26m)
- sync with fc-devel (4.1.1-39)
-* Tue Nov 20 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-39
-- update from gcc-4_1-branch (-r118891:119021)
-  - PRs middle-end/26306, middle-end/29753, target/18553, target/29114,
-	target/29449, tree-opt/29788, tree-optimization/28888
-- fix some C++ vector conversions (PR c++/29734)
-- fix C++ ICE with value dependent const brace enclosed initializer
-  (PR c++/29570)

* Fri Nov 17 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-25m)
- sync with fc-devel (4.1.1-38)
-* Thu Nov 16 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-38
-- update from gcc-4_1-branch (-r118805:118891)
-  - PRs rtl-optimization/29797
-- fix forwprop switch optimization (PR middle-end/29584)

* Thu Nov 16 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-24m)
- sync with fc-devel (4.1.1-37)
- * Tue Nov 14 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-36
-- update from gcc-4_1-branch (-r118571:118805)
-  - PRs c++/29106, c++/29518, fortran/24518, fortran/29216, fortran/29314,
-	fortran/29371, fortran/29387, fortran/29392, fortran/29490,
-	fortran/29565, fortran/29630, fortran/29679, fortran/29713,
-	middle-end/21032, testsuite/28703, tree-opt/28545
-- honor initial conditions and variable types in conversion to perfect
-  nesting for -ftree-loop-linear optimizations (#209297,
-  PR tree-optimization/29581)
-* Tue Nov 14 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-37
-- fix up check_effective_target_fopenmp tcl test for the testsuite
-  framework backport changes

* Sun Nov 12 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-23m)
- update from momonga's trunk (-r11640:12413)
- BuildRequire firefox-devel instead of mozilla-devel
- sync with fc-devel (4.1.1-35)
-* Sat Nov 11 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-35
-- fix libgcj_bc.so dummy lib on i?86/x86_64/ia64/s390/s390x
-* Sat Nov 11 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-34
-- fix libgcj_bc.so symlink and dummy lib placement to avoid 64-bit gcc-java
-  requiring 32-bit libc or vice versa
-- fix ICE on Fortran !$omp continued line followed by !$ conditional
-  line (PR fortran/29759)
-* Wed Nov  8 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-33
-- update from gcc-4_1-branch (-r118468:118571)
-  - PRs fortran/24398, fortran/27701, fortran/29098, fortran/29115,
-	fortran/29211, fortran/29232, fortran/29364, fortran/29373,
-	fortran/29407, libfortran/29627, tree-optimization/29610
-- fix java.net.SocketPermission (Gary Benson, #212739)
-- fix java.util.regex.Matcher (Ito Kazumitsu, #183698, PR classpath/29703)
-- fix # <linenum> <file> <flags> handling in libcpp when switching
-  from system header to non-system header or main source
-  (PR preprocessor/29612)
-- fix gcc configury detection of ld COMDAT support
-- move *.so symlinks from libgcj-devel to gcc-java (#214195)

* Sat Nov  4 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-22m)
- sync with fc-devel (4.1.1-32)
-* Sat Nov  4 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-32
-- update from gcc-4_1-branch (-r118025:118468)
-  - PRs bootstrap/28400, fortran/29067, libgfortran/29563, middle-end/29250,
-	rtl-optimization/28970, rtl-optimization/29631, target/29377,
-	tree-optimization/27891
-  - fix infinite recursion in make_vector_type (#212848,
-    PR tree-optimization/29637)
-- merge gomp fixes from the trunk (-r118133:118134)
-  - PR fortran/29629
-- fix A < 0 ? <sign bit of A> : 0 optimization (#213821, PR middle-end/29695)
-- fix ICE in gfc_get_derived_type (Paul Thomas, #212936, PR fortran/29641)

* Thu Oct 26 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-21m)
- sync with fc-devel (4.1.1-31)
-* Wed Oct 25 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-31
-- update from gcc-4_1-branch (-r117629:118025)
-- PRs c++/20647, c++/25878, c++/26884, c++/27787, c++/28506, c++/28906,
-	c++/29020, c++/29175, c++/29318, c++/29408, c++/29435, c/27184,
-	c/29092, fortran/25091, fortran/25092, fortran/29284, fortran/29321,
-	fortran/29322, fortran/29393, fortran/29403, gcov/profile/26570,
-	inline-asm/29119, middle-end/20491, rtl-optimization/29323,
-	target/25519, target/28825, target/28960, target/29300,
-	testsuite/28829, tree-optimization/26969
-- fix libstdc++.so backwards compatibility with GCC 3.4.x (#210452)
-- fix always_inline attribute at -O0 (Jan Hubicka, PR middle-end/29241)
-- fix function local static vars with used attribute (Jan Hubicka,
-  Richard Guenther, PR middle-end/29299)

* Sat Oct 14 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-20m)
- sync with fc-devel (4.1.1-30)
- * Wed Oct 11 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-30
- - update from gcc-4_1-branch (-r117464:117629)
- - PRs c++/28302, c++/28349, c++/28450, c++/29002, libstdc++/29095,
-	libstdc++/29354, libstdc++/29368, target/28490
- - fix gnu.xml.transform.TransformerImpl (Tom Tromey, #208854,
-   PR classpath/29362)
- add some BuildRequires for libgcj.

* Mon Oct  9 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-19m)
- revert changes in 4.1.1-18m. (see also http://gcc.gnu.org/viewcvs?view=rev&revision=115880)
- added BuildRequires: /usr/bin/fastjar

* Sun Oct  8 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (4.1.1-18m)
- modify patch 1002 (libtool-version)

* Sat Oct  7 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (4.1.1-17m)
- add patch200 (serch fastjar first)

* Sat Oct  7 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.1-16m)
- merge from TUPPA4RI branch

* Fri Oct  6 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-15m)
- sync with fc-devel (4.1.1-29)

* Fri Sep 29 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-14m)
- sync fc-devel (4.1.1-27)

* Mon Sep 25 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-13m)
- sync fc-devel (4.1.1-25)

* Thu Sep 21 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-12m)
- sync fc-devel (4.1.1-24)

* Mon Sep 18 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-11m)
- sync fc-devel (4.1.1-21)

* Sat Sep  9 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (4.1.1-10m)
- fix autoprov and autoreq  

* Fri Sep  8 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.1-9m)
- update 20060828

* Tue Aug 15 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.1-8m)
- sync fc-devel (4.1.1-16)

* Thu Jul 20 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (4.1.1-7m)
- [SECURITY] CVE-2006-3619
- http://gcc.gnu.org/bugzilla/show_bug.cgi?id=28359

* Tue Jul 11 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (4.1.1-6m)
- delete duplicated dir

* Sat Jun 24 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.1-5m)
- sync FC-devel
-- * Tue Jun 20 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-5
-- - fix C++ #pragma omp atomic (Mark Mitchell)
-- 
-- * Mon Jun 19 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-4
-- - update from gcc-4_1-branch (-r114555:114766)
--   - PRs bootstrap/22541, c++/21210, c++/26559, c++/27227, c++/27648,
-- 	c++/27665, c++/27666, c++/27689, c++/27884, c++/27933, c++/27951,
-- 	fortran/27786, java/28024, middle-end/27733, middle-end/27802,
-- 	target/27858, tree-optimization/27830
-- - merge gomp changes from the trunk (-r114642:114643)
--   - PR libgomp/28008
-- - fix -fmerge-all-constants
-- - fix #pragma omp critical handling if not --enable-linux-futex
-- 
-- * Tue Jun 13 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-3
-- - add BuildRequires for elfutils-devel on ia64
-- - fix a reload bug visible on s390x (Andreas Krebbel, #193912,
--   PR middle-end/27959)
-- 
-- * Mon Jun 12 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-2
-- - update from gcc-4_1-branch (-r114107:114555)
--   - PRs ada/27769, c++/20173, c++/26068, c++/26433, c++/26496, c++/27177,
-- 	c++/27385, c++/27447, c++/27451, c++/27601, c++/27713, c++/27716,
-- 	c++/27722, c++/27801, c++/27806, c++/27807, c++/27819, c/25161,
-- 	c/26818, c/27020, c/27718, fortran/14067, fortran/16943,
-- 	fortran/18003, fortran/19015, fortran/19777, fortran/20839,
-- 	fortran/20877, fortran/23091, fortran/23151, fortran/24168,
-- 	fortran/24558, fortran/25047, fortran/25058, fortran/25082,
-- 	fortran/25090, fortran/25098, fortran/25147, fortran/25746,
-- 	fortran/26551, fortran/27155, fortran/27320, fortran/27411,
-- 	fortran/27449, fortran/27470, fortran/27524, fortran/27552,
-- 	fortran/27584, fortran/27613, fortran/27655, fortran/27662,
-- 	fortran/27709, fortran/27897, libgcj/26483, libgfortran/24459,
-- 	libgfortran/27757, middle-end/27743, middle-end/27793,
-- 	target/25758, target/26223, target/27790, target/27842,
-- 	testsuite/27705, tree-optimization/26242, tree-optimization/26622
-- - merge gomp changes from the trunk (-r114518:114520 and -r114524:114525)
--   - PRs preprocessor/27746, c/27747, c++/27748, fortran/27916
-- - don't generate decls with the same DECL_UID in C++ FE (PR middle-end/27793)

* Sat Jun 10 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (4.1.1-4m)
- delete test code (gomen nasai)

* Sat Jun 10 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (4.1.1-3m)
- delete duplicated dir

* Mon May 29 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.1-2m)
- sparc32 and ppc32 packages are rewound. 

* Fri May 26 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.1-1m)
- update 4.1.1
- sync fc-devel
- * Thu May 25 2006 Jakub Jelinek <jakub@redhat.com> 4.1.1-1
- - update from gcc-4_1-branch (-r113848:114107)
-   - GCC 4.1.1 release
-   - PR fortran/27553
- - fix i386/x86_64 -O0 -fpic link failure (#192816, PR target/27758)
- - fix gcjh on 64-bit hosts (#192700)
- - -fvar-tracking fixes needed for SystemTap (Alexandre Oliva, BZ#2438)
-
- * Wed May 17 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-19
- - update from gcc-4_1-branch (-r113785:113848)
-   - PRs c++/26757, c++/27339, c++/27491, driver/26885, rtl-optimization/14261,
-       target/26600, tree-optimization/27603
- - merge gomp changes from the trunk (-r113513:113514, -r113821:113823 and
-   -r113845:113846)
-   - PRs middle-end/27415, middle-end/27573
- - optimize handling of large CONSTRUCTORs (Bernd Schmidt,
-   PR middle-end/27620)
-
- * Mon May 15 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-18
- - update from gcc-4_1-branch (-r113722:113785)
-   - PRs c++/27315, c++/27581, c++/27582, rtl-optimization/22563
- - merge gomp changes from the trunk (-r113786:113790)
-
- * Sun May 14 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-17
- - make -mtune=z9-109 the default on s390{,x} (#184630)
-
- * Sat May 13 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-16
- - update from gcc-4_1-branch (-r113637:113722)
-   - PRs bootstrap/26872, c++/27547, fortran/20460, fortran/24549,
-       middle-end/27384, middle-end/27488, target/26545, target/27158
- - fix libgcj.pc location and content on x86_64, ppc64 and s390x (#185230)
- - make __dso_handle const, so that it is added into .data.rel.ro section
-   in shared libraries
- - fix a typo in __builtin_object_size computation (Richard Guenther,
-   PR tree-optimization/27532)
- - fix ICE on -O0 -g if static local variables are in unreachable code blocks
-   (Jan Hubicka, PR debug/26881)
- - fix ICEs with conflicts across abnormal edges (Zdenek Dvorak,
-   PRs tree-optimization/27283, tree-optimization/27548,
-   tree-optimization/27549)
- - warn about OpenMP section 2.9 region nesting violations
- - fix OpenMP fortran array REDUCTION with -fbounds-check (PR fortran/27446)
- - fix OpenMP {{FIRST,LAST}PRIVATE,REDUCTION} in orphaned construct on
-   Fortran dummy argument (PR middle-end/27416)
- - fix ICE on #pragma omp for unsigned iteration variable (PR c/27499)

* Sat May 13 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-9m)
- sync fc-devel
- * Fri May 12 2006 Jakub Jelinek <jakub redhat com> 4.1.0-16
- - update from gcc-4_1-branch (-r113637:113722)
-   - PRs bootstrap/26872, c++/27547, fortran/20460, fortran/24549,
- 	middle-end/27384, middle-end/27488, target/26545, target/27158
- - fix libgcj.pc location and content on x86_64, ppc64 and s390x (#185230)
- - make __dso_handle const, so that it is added into .data.rel.ro section
-   in shared libraries
- - fix a typo in __builtin_object_size computation (Richard Guenther,
-   PR tree-optimization/27532)
- - fix ICE on -O0 -g if static local variables are in unreachable code blocks
-   (Jan Hubicka, PR debug/26881)
- - fix ICEs with conflicts across abnormal edges (Zdenek Dvorak,
-   PRs tree-optimization/27283, tree-optimization/27548,
-   tree-optimization/27549)
- 
- * Tue May  9 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-15
- - update from gcc-4_1-branch (-r113623:113637)
-   - PR fortran/27378
- - update from trunk (-r109500:109501, -r109670:109671, -r111341:111342,
- 		     -r111704:111705, -r112546:112547, -r113111:113112,
- 		     -r113339:113341, -r113511:113513)
- - fix loop peeling (Zdenek Dvorak, #190039, PR rtl-optimization/27335)
- 
- * Mon May  8 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-14
- - update from gcc-4_1-branch (-r113489:113623)
-   - PRs c++/27422, c++/27427, fortran/24813, fortran/25099, fortran/25681,
- 	fortran/27269, fortran/27324, libfortran/26985, objc/27240,
- 	target/26481, target/26765, tree-optimization/25985,
- 	tree-optimization/27151
- - fix zero size field handling in structalias (Richard Guenther,
-   PR tree-optimization/27409)
- - fix PR tree-optimization/27136 (Richard Guenther)
- - fix classification of invalid struct types on x86_64 (Volker Reichelt,
-   PR target/27421)
- 
- * Wed May  3 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-13
- - update from gcc-4_1-branch (-r113416:113489)
-   - PRs c/25309, target/27374, target/27387, tree-optimization/27364
- - merge gomp changes from trunk (-r113267:113271, -r113411:113412,
-   -r113452:113456, -r113482:113483, -r113493:113494)
-   - PR fortran/27395
- - additional gomp fixes (PRs c++/27359, middle-end/27388)
- - package SYSCALLS.c.X for protoize (#190047)
- - fix gcj -fprofile-arcs -ftest-coverage (Alexandre Oliva, #177450)
- - reenable profiledbootstrap
- - in 64-bit builds remove 32-bit /usr/lib/lib* libraries from the
-   buildroots (and similarly on 32-bit builds remove 64-bit /usr/lib64/lib*)
-   before AutoReq generation (#190541)
- 
- * Mon May  1 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-12
- - update from gcc-4_1-branch (-r113242:113416)
-   - PRs c++/26534, c++/26912, c++/27094, c++/27278, c++/27279, fortran/26017,
- 	libgfortran/20257, libgfortran/27304, libgfortran/27360,
- 	libstdc++/26513, middle-end/26565, middle-end/26869,
- 	rtl-optimization/26685, target/26826
- - merge gomp changes from trunk (-r113255:113256, -r113420:113421)
-   - PRs libgomp/25865, c/27358
- - assorted gomp fixes (PRs middle-end/27325, middle-end/27310,
-   middle-end/27328, middle-end/27337, c++/26943)
- - fix builtin memset (Alan Modra, PR middle-end/27260, PR middle-end/27095)
- 
- * Tue Apr 25 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-11
- - update from gcc-4_1-branch (-r113149:113242)
-   - PRs c/25875, c/26774, fortran/18803, fortran/25597, fortran/25669,
- 	fortran/26787, fortran/26822, fortran/26834, fortran/27089,
- 	fortran/27113, fortran/27122, fortran/27124, target/21283,
- 	target/26961
- - fix number of iterations computation (Zdenek Dvorak, #189376,
-   PR tree-optimization/27285)
- - fix handling of volatile in the inliner (Andrew Pinski, Richard Guenther,
-   PR tree-optimization/27236)
- - strip useless type conversions in the inliner (Andrew Pinski,
-   Richard Guenther, PR tree-optimization/27218)

* Sun Apr 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-8m)
- comment out Patch15: gcc41-pr21581.patch
- use parallel build
- cleanup 

* Fri Apr 21 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-7m)
- import FC-devel
- * Fri Apr 21 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-10
- - update from gcc-4_1-branch (-r113110:113149)
-   - PRs libgcj/21941, libgcj/27170, libgcj/27231, libgfortran/27138,
- 	libstdc++/26424, mudflap/26789
- - improve dir/../-stripping code to support /usr/lib64 and /usr/lib in
-   separate AFS mountpoints (Alexandre Oliva, #137200)
- - fix fortran real(16) transpose and reshape on 32-bit architectures
-   (PR fortran/26769)
- - fix i?86/x86_64 vector extraction (Alexandre Oliva, #187450)
- - fix testcase for ppc32 va_arg bug
- - fix testsuite log uuencoding
- - fix acats timeout framework
- 
- * Thu Apr 20 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-9
- - update from gcc-4_1-branch (-r112951:113110)
-   - PRs c++/10385, c++/26036, c++/26365, c++/26558, classpath/27163,
- 	fortran/26769, libgcj/27171, libgfortran/26766, libstdc++/27162,
- 	middle-end/27095, middle-end/27134, target/27182,
- 	tree-optimization/26643, tree-optimization/26821,
- 	tree-optimization/26854, tree-optimization/27087
- - fix ppc32 va_arg bug (Alan Modra)
- - assorted gomp fixes (PRs c++/25874, middle-end/25989, c/25996, c/26171,
-   middle-end/26913)
- - fix pretty printing C array types (#188944)
- - fix ICE on unprototyped alloca (PR tree-optimization/26865)
- - fix truncation optimization overflow handling (PR middle-end/26729)
- - uuencode dejagnu testsuite log files in rpmbuild output

* Wed Apr 18 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-6m)
- import any patch
-  PRs middle-end/26565, tree-optimization/26643, 
-      pr26826 , pr20425

* Sat Apr 15 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-5m)
- sync FC-devel
- * Fri Apr 14 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-8
- - update from gcc-4_1-branch (-r112825:112951)
-   - PRs c++/26122, c++/26295, fortran/23634, fortran/25619, fortran/26257,
-         libgcj/23829, libgcj/26522, libgfortran/26890, target/27006
-   - merge gomp changes from trunk (-r112934:112935)
-   - PR libgomp/26651
-   - fix ICE in gomp handling of EH regions (PR middle-end/26823)

* Wed Apr 12 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-4m)
- sync FC-devel
-* Mon Apr 10 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-7
-- update from gcc-4_1-branch (-r112727:112825)
-  - PRs fortran/19101, fortran/25031, fortran/26779, fortran/26891,
-       fortran/26976, target/26508, tree-optimization/26919
-- fix libgfortran printing of REAL*16 for IEEE quad and IBM extended formats
-  (PR libgfortran/24685)
-- fix Fortran -fbounds-check (Roger Sayle, #188409, PR middle-end/22375)
-- fix Java StackTraceElement.toString() (Mark Wielaard, #183212,
-  PR classpath/27081)
-- fix -fopenmp -static

* Sun Apr  9 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-3m)
- sync fc-devel
- * Thu Apr  6 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-6
- - update from gcc-4_1-branch (-r)
-   - PRs classpath/24752, classpath/27028, libgcj/26625, libgcj/27024,
-         tree-optimization/26996
- - reenable PR c++/19238, c++/21764 fixes, only PR c++/21581 is not
-   applied
- - better fix for Java GC vs. pthread_create (Bryce McKinlay, #,
-   PR libgcj/13212)
- - fix objc_push_parm (#185398)
- - fix ICE with -feliminate-dwarf2-dups and using namespace (#187787,
-   PR debug/27057)
- 
- * Wed Apr  5 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-5
- - update from gcc-4_1-branch (-r112431:112706)
-   - PRs bootstrap/26936, bootstrap/27023, classpath/25924, fortran/19303,
-         fortran/25358, fortran/26816, java/25414, java/26042, java/26858,
-         libfortran/26735, libgcj/26990, libstdc++/26777, testsuite/25741,
-         tree-optimization/18527, tree-optimization/26763,
-         tree-optimization/26830
- - merge gomp changes from trunk (-r112602:112603 and -r112618:112619)
- - temporarily revert PR c++/21764, c++/19238, c++/21581 fixes (#187399)

* Thu Mar 30 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-2m)
- sync fc-devel
-  * Tue Mar 28 2006 Jakub Jelinek <jakub redhat com> 4.1.0-4
- - update from gcc-4_1-branch (-r111697:112431)
-   - PRs ada/25885, c/26004, fortran/17298, fortran/20935, fortran/20938,
-	 fortran/23092, fortran/24519, fortran/24557, fortran/25045,
-	 fortran/25054, fortran/25075, fortran/25089, fortran/25378,
-	 fortran/25395, fortran/26041, fortran/26054, fortran/26064,
-	 fortran/26107, fortran/26277, fortran/26393, fortran/26716,
-	 fortran/26741, libfortran/21303, libfortran/24903, libgcj/24461,
-	 libgcj/25713, libgcj/26103, libgcj/26688, libgcj/26706,
-	 libgfortran/26499, libgfortran/26509, libgfortran/26554,
-	 libgfortran/26661, libgfortran/26880, libstdc++/26132,
-	 middle-end/18859, middle-end/19543, middle-end/26557,
-	 middle-end/26630, other/26489, target/25917, target/26347,
-	 target/26459, target/26532, target/26607, tree-optimization/26524,
-	 tree-optimization/26587, tree-optimization/26672
-   - fix visibility and builtins interaction (Jason Merrill,
-     PR middle-end/20297, #175442)
- - merge gomp changes from trunk (-r112022:112023, -r112250:112251,
-   -r112252:112253, -r112350:112351 and -r112282:112283)
-   - PRs c++/26691, middle-end/26084, middle-end/26611, c++/26690,
- 	middle-end/25989
- - support visibility attribute on namespaces (Jason Merrill, PR c++/21764,
-   PR c++/19238)
- - use hidden visibility for anonymous namespaces by default (Jason Merrill,
-   PR c++/21581)

* Sat Mar 10 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-1m)
- update 4.1.0 Release

* Sat Feb 25 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.13m)
- update 4.1.0-RC2 + patch
- BuildRequires: glibc >= 2.3.90-5m
- enable long-double-128

* Sat Feb 18 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.12m)
- sync patch FC-devel(4.1.0-0.28)

* Wed Feb 15 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.11m)
- sync patch FC-devel(4.1.0-0.27)

* Mon Feb  6 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.10m)
- sync FC-devel
- * Sat Feb  4 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.22
- - fix ia64 debug info patch
- - fix libjava pthread_create wrapper patch
- 
- * Sat Feb  4 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.21
- - update from gcc-4_1-branch (-r110433:110582)
-   - PRs c++/25342, c++/25979, fortran/20845, fortran/24266,
- 	fortran/24958, fortran/25072, libstdc++/21554, middle-end/24901,
- 	middle-end/25977, middle-end/26001, target/25864, target/25926,
- 	target/25960
-   - put ia64 read-only sections that require runtime relocations
-     even in -fno-pic code into .data.rel.ro etc. sections
-     rather than .rodata to avoid DT_TEXTREL binaries
-     (Richard Henderson, PR target/26090)
- - merge gomp changes from trunk (-r110511:110512 and -r110549:110552)
- - fix ia64 debug info coverage of epilogues (Alexandre Oliva, PR debug/24444)
- - export pthread_create from libgcj.so.7 as a wrapper around
-   libpthread.so.0's pthread_create that handles GC (Anthony Green, Tom Tromey)
- - BC-ABI java lookup fix (Andrew Haley, #179070, #178156)
- - on sparc64 emit .register %g7,#ignore instead of .register %g7,#scratch
-   to avoid problems with TLS or -fstack-protector
- - switch to IBM extended format long double by default on ppc and ppc64
- - switch to IEEE 754 quad format long double by default on s390, s390x,
-   sparc32 and alpha

- * Wed Feb  1 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.20
- - merge from gomp-20050808-branch (up to -r110392)
-   - fix PR c++/25874 (Diego Novillo)
- 
- * Wed Feb  1 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.19
- - s390{,x} long double patch fix for s390x ICEs on test-ldouble
-   and tst-align2 (Andreas Krebbel)
- 
- * Tue Jan 31 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.18
- - update from gcc-4_1-branch (-r110317:110433)
-   - PRs c++/25855, c++/25999, fortran/17911, fortran/18578, fortran/18579,
- 	fortran/20857, fortran/20885, fortran/20895, fortran/25030,
- 	fortran/25835, fortran/25951, java/21428, libgfortran/25835,
- 	target/14798, target/25706, target/25718, target/25947,
- 	target/26018, testsuite/25318
- - add -mtune=generic support for i?86 and x86_64 (Jan Hubicka, H.J. Lu,
-   Evandro Menezes)
- - use -mtune=generic by default if neither -march= nor -mtune= is specified
-   on command line on i?86 or x86_64
- - updated s390{,x} long double patch, fixing ICEs on s390x glibc build
-   (Andreas Krebbel, Ulrich Weigand)

* Wed Feb  1 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.9m)
- sync FC-devel
-* Sat Jan 28 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.17
-- update from gcc-4_1-branch (-r110062:110317)
-  - PRs ada/20548, ada/21317, bootstrap/25859, c++/25552, c++/25856,
-        c++/25858, c++/25895, c/25892, fortran/18540, fortran/20852,
-        fortran/20881, fortran/23308, fortran/24276, fortran/25084,
-        fortran/25085, fortran/25086, fortran/25124, fortran/25416,
-        fortran/25538, fortran/25625, fortran/25710, fortran/25716,
-        fortran/25901, fortran/25964, java/25816, other/24829,
-        rtl-optimization/24626, rtl-optimization/25654, target/24831,
-        testsuite/24962, testsuite/25590
-- atomic builtin fixes (Richard Henderson)
-- -mlong-double-128 support on ppc32 (David Edelsohn, Alan Modra)
-- -mlong-double-128 support on s390 and s390x (Andreas Krebbel,
-  Ulrich Weigand)

* Sun Jan 22 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.8m)
- remove "-ffast-math" option. crappy libgcc.
- update from gcc-4_1-branch (-r109815:110081)
- - PRs ada/24533, classpath/20198, c/25805, c++/16829, c++/22136,
-       c++/25836, c++/25854, fortran/20869, fortran/20875, fortran/25024,
-       fortran/25785, libgcj/25840, libgfortran/25631, libgfortran/25697,
-       libstdc++/25823, libstdc++/25824, target/25731, testsuite/25171

* Sat Jan 21 2006 Yohsuke Ooi <meke@momonga-linux.org>
-  (4.1.0-0.7m)
- sync fc-devel
-- * Tue Jan 17 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.15
--  - update from gcc-4_1-branch (-r109401:109815)
--     - PRs c++/24824, c++/25386, c++/25663, c/25682, classpath/25803,
--           fortran/12456, fortran/20868, fortran/20870, fortran/21256,
--           fortran/21977, fortran/22146, fortran/24640, fortran/25029,
--           fortran/25093, fortran/25101, fortran/25486, fortran/25598,
-- 	     fortran/25730, libgcj/21637, libgcj/23499, libgfortran/25598,
--           libstdc++/23591, libstdc++/25472, rtl-optimization/24257,
--           rtl-optimization/25367, rtl-optimization/25662, target/20754,
--           target/25042, target/25168, testsuite/25728, testsuite/25777,
--           tree-opt/24365, tree-optimization/23109, tree-optimization/23948,
--           tree-optimization/24123, tree-optimization/25125
--  - update from gomp-20050608-branch (up to -r109816)
--  - fix ppc32 libffi (#177655)
--  - fix lookup_conversions_r (#177918)
--  - define __STDC__ as a normal macro rather than a preprocessor builtin
--    unless it needs to change its value between system and non-system
--    headers (PR preprocessor/25717)

* Sat Jan 14 2006 Yohsuke Ooi <meke@momonga-linux.org>
  (4.1.0-0.6m)
- update gcc-20060114-diff.bz2 (gcc-4_1-branch -r109498:109683)
-- PR tree-opt/24365, PR tree-optimization/23109, PR tree-optimization/23948, 
-- PR tree-optimization/24123, PR target/25042, PR target/20754, PR rtl-optimization/25367
-- PR c++/24824, PR c++/25386, PR fortran/25486, PR fortran/25730, 
-- PR fortran/24936, PR fortran/21977, PR fortran/25093, PR fortran/22146,PR fortran/25029
-- PR fortran/21256, PR fortran/20868, PR fortran/20870
-- PR libstdc++/23591, PR libstdc++/25472, PR libgcj/21637

* Mon Jan  9 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-0.5m)
- clean up spec file.
- add specopt "do_test" : no "make check"
- remove any "global" tag: gcc_opt_inst, pkg_suffix, bin_suffix
- update gcc-20060109-diff.bz2 (gcc-4_1-branch 109401:109498 )
--  PR fortran/24268, PR fortran/25101, PR fortran/24640,
--  PR libgfortran/25598, PR libgcj/23499, PR fortran/12456
--  PR rtl-optimization/25662, PR tree-optimization/25125
- sync fc-devel 4.1.0-14
- * Fri Jan  6 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.14
- - update from gcc-4_1-branch (-r109369:109401)
-   - PR fortran/23675
-   - fix Java shutdown hook (Tom Tromey, #165136)
- - fix libjava/shlibpath.m4 (PR libgcj/24940)
- 
- * Thu Jan  5 2006 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.13
- - update from gcc-4_1-branch (-r108957:109369)
-   - PRs c++/23171, c++/23172, c++/24671, c++/24782, c++/25294, c++/25417,
- 	c++/25439, c++/25492, c++/25625, c++/25632, c++/25633, c++/25634,
- 	c++/25635, c++/25637, c++/25638, c/25183, c/25559, debug/25562,
- 	fortran/18990, fortran/19362, fortran/20244, fortran/20862,
- 	fortran/20864, fortran/20889, fortran/22607, fortran/23152,
- 	fortran/25018, fortran/25053, fortran/25055, fortran/25063,
- 	fortran/25064, fortran/25066, fortran/25067, fortran/25068,
- 	fortran/25069, fortran/25106, fortran/25391, fortran/25532,
-  	fortran/25586, fortran/25587, libgcj/9715, libgcj/19132,
- 	libgfortran/25139, libgfortran/25419, libgfortran/25510,
- 	libgfortran/25550, libgfortran/25594, middle-end/24827, objc/25328,
- 	rtl-optimization/21041, rtl-optimization/25130, target/24342,
- 	target/25554, target/25572, testsuite/25214, testsuite/25441,
- 	testsuite/25442, testsuite/25444, tree-opt/25513
-   - create java Package for compiled classes which are linked in but
-     loaded by the system class loader (Tom Tromey, #176956)
-   - fix posix_memalign prototype in <mm_malloc.h> (#176461)
- - update from gomp-20050608-branch (up to -r109349)
- - buildrequire libXtst-devel (#176898)
- - fix built in path to classmap.db on x86_64, s390x and ppc64 (#176562)
- - fix debug info for preprocessed Fortran code (#175071, PR fortran/25324)

* Sun Jan  1 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-0.4m)
- change package name. gcc41 -> gcc

* Sun Jan  1 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-0.3m)
- move libssp package. gcc -> libgcc
- change package name. if "gcc_opt_inst = 1" : libgomp -> libgomp41
- sync FC devel-4.1.0-0.12

* Thu Dec 22 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-0.2m)
- add libssp* , /usr/include/ssp
- add %{_prefix}/bin/%{gcc_target_platform}-gfortran%{bin_suffix}
- Provide gcc-g77
- Provide gcc41-gfortran
- sync Fedora-4.1.0-0.10
- * Wed Dec 21 2005 Jakub Jelinek <jakub@redhat.com> 4.1.0-0.10
- - update from gcc-4_1-branch (-r108539:108861)
-   - PRs ada/18659, ada/18819, c++/20552, c++/21228, c++/24278, c++/24915,
-         fortran/18197, fortran/25458, libgfortran/25039, libgfortran/25264,
-         libgfortran/25349, libobjc/14382, libstdc++/25421, middle-end/22313,
-         middle-end/24306, rtl-optimization/23837, rtl-optimization/25224,
-         rtl-optimization/25310, target/24969, testsuite/25215,
-         tree-optimization/23838, tree-optimization/24378
- - update from gomp-20050608-branch (up to -r108859)
-   - fix _Pragma handling (Richard Henderson, PR preprocessor/25240)
- - fix reload re-recognition of insns (Alan Modra, PR rtl-optimization/25432)
- - don't peephole RTX_FRAME_RELATED_P insns (Andrew Haley, PR
-   middle-end/25121)

* Sat Dec 17 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (4.1.0-0.1m)
- first commit gcc41
- sync Fedora gcc-4.1.0-0.9
